/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 *
 * @include chrome://opensi/content/libs/verif.js
 * @include chrome://libopensi/content/load_rdf.js
 * @include chrome://opensi/content/libs/util.js
 *
 */

var focus_input = ''; // id du textbox ayant le focus.
var id_select = -1;
var force = false;
var dsource; // source de donnes RDF de l'arbre.
var compte;
var solde;
var dateop;
var listeecritures;
var rExp = / /gi;
var popup;

function pgload() {
  try {
    return document.getElementById("pgload");
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#pgload : ' + e);
  }
}

function retour_menuAutres() {
  try {
    var page = "chrome://opensi/content/compta/user/autres/menu_autres.xul?" + cookie() ;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#retour_menuAutres : ' + e);
  }
}

function retour_menuPrincipal() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie() ;
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#retour_menuPrincipal : ' + e);
  }
}

function retour_choixExercice() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_dossier.xul?" + cookie();
    page += "&Libelle=" + parent.document.getElementById("nom_dossier").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#retour_choixExercice : ' + e);
  }
}

function retour_choixDossier() {
  try {
    var page = "chrome://opensi/content/compta/user/menu.xul?" + cookie();
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#retour_choixDossier : ' + e);
  }
}


/*****************************************************
 *  @return l'id de l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree_id(){
  return 'transactions';
}

/*****************************************************
 *  @return le pointeur vers l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree(){
  try {
    return document.getElementById(get_tree_id());
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#get_tree : ' + e);
  }
}

function get_root() {
  try {
    return dsource.getNode("http://www.opensi.org/compta/bank");
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#get_root : ' + e);
  }
}

/****************************************************
 *  Correspondance entre l'id d'un textbox et le target RDF associ
 *  @param id : l'identifiant du textbox
 *  @return le target associ
 ****************************************************/
function targetname(id) {
  
  try {
  
    switch(id) {
      case 'input_date':
        return "http://www.opensi.org/compta/bank/rdf#date";
        break;
      case 'input_day':
        return "http://www.opensi.org/compta/bank/rdf#day";
        break;
      case 'input_month':
        return "http://www.opensi.org/compta/bank/rdf#month";
        break;
      case 'input_year':
        return "http://www.opensi.org/compta/bank/rdf#year";
        break;
      case 'input_debit':
        return "http://www.opensi.org/compta/bank/rdf#debit";
        break;
      case 'input_credit':
        return "http://www.opensi.org/compta/bank/rdf#credit";
        break;
      case 'input_num':
        return "http://www.opensi.org/compta/bank/rdf#num";
        break;
      case 'input_compte':
        return "http://www.opensi.org/compta/bank/rdf#compte";
        break;
      case 'input_libelle':
        return "http://www.opensi.org/compta/bank/rdf#libelle";
        break;
      case 'input_prop':
        return "http://www.opensi.org/compta/bank/rdf#prop";
        break;
      case 'input_base':
        return "http://www.opensi.org/compta/bank/rdf#base";
        break;
      case 'input_verrouille':
        return "http://www.opensi.org/compta/bank/rdf#verrouille";
        break;
      case 'input_bloque':
        return "http://www.opensi.org/compta/bank/rdf#bloque";
        break;
      default:
        return '';
    }
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#targetname : ' + e);
  }

}

function get_child(id) {

  try {
  
    var child = null;

    var index = id + 1;
    var root = get_root();
    var children = root.getChildren();
    var found = false;

    while ((children.hasMoreElements()) && (! found) ) {
      var c = children.getNext();
      
      if (root.getChildIndex(c) == index) {
        child = c;
        found = true;
      }
    }
    
    return child;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#get_child : ' + e);
  }
  
}

function init() {
	try {
/*    var x = screen.width * 0.1 ;
    var y = screen.height * 0.1 ;
    var w = screen.width * 0.8 ;
    var h = screen.height * 0.8 ;    
    window.resizeTo(w,h);
    window.moveTo(x,y);*/

    pgload().collapsed = false;

  	var paramlist = "&Page=Import/ImportBank.tmpl&ContentType=xml";
    paramlist += "&Fichier=" + ParamValeur("Fichier");
    paramlist += "&Code_Journal=" + ParamValeur("Code_Journal");

    dsource = new RDFDataSource(); 
    load_rdf_async('transactions',getUrlOpeneas(paramlist),init_tree);
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#init : ' + e);
  }
}

function init_tree(ds) {

  try {

/*    dsource.deleteRecursive("http://www.opensi.org/compta/bank");
    var datasource = dsource.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource);
*/

    ds.copyAllToDataSource(dsource);

    var datasource2 = ds.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource2);
    var datasource = dsource.getRawDataSource();
    get_tree().database.AddDataSource(datasource);
    
    if (get_tree().view == null) {
      alert("Il n'y aucune transaction bancaire en attente pour ce journal...");
      retour_menuAutres();
      return false;
    } 
    
    document.getElementById("input_libelle").focus();
    focus_input = "input_compte";
    document.getElementById(focus_input).focus();
    document.getElementById('page').value = "Nombre de pages restantes : " + get_nb_pages();

    var root = get_root();
    var children = root.getChildren();
    var v = get_tree().view;
    var errnoexo = false;
    var errbloque = false;
    var errverrouille = false;

    while (children.hasMoreElements()) {
      var child = children.getNext();
      var index = root.getChildIndex(child) - 1;
      var base = v.getCellText(index,'base');
      var bloque = v.getCellText(index,'bloque');
      var verrouille = v.getCellText(index,'verrouille');
      if (isEmpty(base)) errnoexo = true;
      if (bloque == "1") errbloque = true;
      if (verrouille == "1") errverrouille = true;      
    }

    var url = "chrome://opensi/content/compta/util/upload.xul?onlywait=true" ;

    if (errnoexo) {
      alert('errnoexo');
      setTimeout('deleteNoExo()',200);
      return false;
    }
    if (errbloque) {
      if (confirm('bloque')) {
        popup = window.openDialog(url,'upload','chrome');
        setTimeout('deleteBloque()',200);
      } else {
        retour_menuAutres();
      }
      return false;
    }
    if (errverrouille) {
      if (confirm('verrouille')){
        popup = window.openDialog(url,'upload','chrome');
        setTimeout('deleteVerrouille()',200);
      } else {
        retour_menuAutres();
      }
      return false;
    }

    if (get_tree().view.rowCount == 0) {
      alert("Il n'y aucune transaction bancaire en attente pour ce journal...");
      retour_menuAutres();
      return false;
    }
    
    select_begin();

    var corps = cookie() + "&Page=Compta/GetContrepartie.tmpl&ContentType=xml";
    corps += "&Code_Journal=" + ParamValeur('Code_Journal');
    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,suiteInitTree);

	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#init_tree : ' + e);
  }

}

function suiteInitTree(httpRequest) {
  
  try {
    
    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + httpRequest.status);
    } else {
      var contenu=httpRequest.responseXML;
      var session = contenu.documentElement;
      compte =  session.getAttribute('compte');
      var soldecompte =  parseFloat(session.getAttribute('solde'));
      var v = get_tree().view;
      var soldebefore = parseFloat(v.getCellText(v.selection.currentIndex,'soldebefore'));
      var delta = soldecompte + soldebefore ;
      if (delta != 0) {
        var msg = "Attention : aprs intgration de ces donnes,\n";
        msg += "votre solde comptable sera diffrent de votre solde bancaire\n";
        msg += "d'un montant de " + format(delta,2,' ',0) + " Euros.";
        alert(msg);
      }
    }

    pgload().collapsed = true;

	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#suiteInitTree : ' + e);
  }

}

function deleteNoExo() {
  deleteElements('noexo');
}
function deleteBloque() {
  deleteElements('bloque');
}
function deleteVerrouille() {
  deleteElements('verrouille');
}

function deleteElements(tag) {

  try {
    
    var corps = '&Page=Compta/UpdateDatabase/update.tmpl&ContentType=xml&' + cookie();
    corps += '&req=supprbanque';  
    corps += '&Code_Journal=' + ParamValeur('Code_Journal');
    corps += '&tag=' + tag;

    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,suiteInitTree);

	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#deleteElements : ' + e);
  }

}

function suiteDeleteElements(httpRequest) {

  try {

    popup.close();

    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + httpRequest.status);
      return false;
    } 
    
    refreshEcritures(''); 

	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#suiteDeleteElements : ' + e);
  }

}

/****************************************************
 *  Excut lorsqu'une zone de saisie prend le focus.
 *  affecte le nom de classe 'focus'  la zone.
 *  @param t : la zone de saisie.
 *  @param id : l'identifieur de la zone de saisie.
 ****************************************************/
function focus_field(t,id){

  try {

    t.setSelectionRange(0,t.textLength);
    focus_input = id;
    anc_value = t.value;
    t.className = 'focus';
    get_tree().treeBoxObject.focused = true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#focus_field : ' + e);
  }

}

/****************************************************
 * Rcupre le nombre d'critures sur la base
 ****************************************************/
function get_nb_pages(){

  try {

    var corps = cookie() + "&Page=Compta/GetNbEcrituresBanque.tmpl&ContentType=xml";
    corps += "&Code_Journal=" + ParamValeur('Code_Journal');
    var httpRequest = requeteHTTP(corps);

    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + httpRequest.status);
      return '';
    } else {
      var contenu=httpRequest.responseXML;
      var session = contenu.documentElement;
      var nbecr =  session.getAttribute('nb');
      return parseInt(nbecr/20+1);
    }  
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#get_nb_pages : ' + e);
  }

}

/****************************************************
 *  Excut lorsqu'une zone de saisie perd le focus.
 *  affecte le nom de classe 'focus'  la zone.
 *  @param t : la zone de saisie.
 *  @param id : l'identifieur de la zone de saisie.
 ****************************************************/
function blur_field(t,id){
  t.className = 'normal';
}

/****************************************************
 *  Affecte aux zones de saisie les valeurs correspondant
 *   la ligne slectionne de l'arbre.
 ****************************************************/
function reporter() {
  
  try {
    
    id_select = get_tree().currentIndex;
    var v = get_tree().view;
    
    if (id_select == -1) return false;
      
    var compte = v.getCellText(v.selection.currentIndex,'compte');
    document.getElementById('input_compte').value = compte;
    if (isEmpty(compte)) {
      document.getElementById('libelle_compte').value = '';
      document.getElementById('solde_compte').value = '';
    } else {
      maj_aff_compte(document.getElementById('input_compte'),false) ;
    }
    var libelle = v.getCellText(v.selection.currentIndex,'libelle');
    document.getElementById("input_libelle").value = libelle;
    document.getElementById(focus_input).focus();

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#reporter : ' + e);
  }

}

/****************************************************
 *  Mise  jour des valeurs du solde et du libell
 * du compte affich dans la ligne de saisie.
 ****************************************************/
function maj_aff_compte(t,rech) {
  
  try {
  
    var compte = t.value;
    while (compte.length < 8) compte += '0';
    var paramlist = cookie() + "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
    paramlist += "&Numero_Compte=" + compte;

    var p = requeteHTTP(paramlist);
  
    if (p.status == "0") return false;
    
    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
    } else {
      var contenu=p.responseXML;
      var session = contenu.documentElement;
      if (session.getElementsByTagName('numero').length  == 0 ) {
        if (rech) {
          recherche_compte(t);
          return '';
        }
      } else if (t.id == 'input_compte') {
        var l = session.getElementsByTagName('libelle')[0];
        document.getElementById('libelle_compte').value = l.firstChild.data;
        var l = session.getElementsByTagName('gen')[0];
        document.getElementById('type_compte').value = l.firstChild.data;
        var s = session.getElementsByTagName('solde')[0];
        var d = session.getElementsByTagName('debit')[0]; 
        var c = session.getElementsByTagName('credit')[0];
        document.getElementById('solde_compte').value = s.firstChild.data;
        document.getElementById('debit_compte').value = d.firstChild.data;
        document.getElementById('credit_compte').value = c.firstChild.data;
        var os = session.getElementsByTagName('old_solde')[0];
        var od = session.getElementsByTagName('old_debit')[0]; 
        var oc = session.getElementsByTagName('old_credit')[0];
        document.getElementById('old_solde_compte').value = os.firstChild.data;
        document.getElementById('old_debit_compte').value = od.firstChild.data;
        document.getElementById('old_credit_compte').value = oc.firstChild.data;
      }

    }
    
    return compte;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#maj_aff_compte : ' + e);
  }

}

/****************************************************
 *  Effectue une recherche de compte
 *  @param t la zone de saisie  affecter.
 ****************************************************/
function recherche_compte(t){
  try {
    var compte = t.value;
    var id = t.id
    var url = "chrome://opensi/content/compta/util/rechcompte.xul?" + cookie();
    window.openDialog(url,'rechcompte','chrome,modal',compte,id,true);
    change_compte();
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#recherche_compte : ' + e);
  }
}


/****************************************************
 *  Excut lorsque l'utilisateur appuie sur une touche du clavier.
 *  @param e : la touche du clavier
 ****************************************************/
function keypress(e) {
  try {
    switch (e.keyCode) {
      case 33: // 'PageUp'
        select_up();
        break;
      case 34: // 'PageDown'
        select_down();
        break;
      case 35: // 'Fin'
        select_end();
        break;
      case 36: // 'Debut'
        select_begin();
        break;
      case 37: // '<-'
      case 27: // 'Echap'
        focus_prev();
        break;
      case 38: // '^'
        select_prev();
        break;
      case 13: // 'Enter'
      case 39: // '->'
        focus_next();
        break;
      case 9: // TAB
//        var f;
//        switch (focus_input) {
//        }
//        f.focus();
        break;
      case 40: // 'v'
        select_next();
        break;
/*
      case 46: // 'Suppr'
        supprimer();
        break;
*/
      case 114: // 'F3'
        reprise_lib_compte();
        break;
        
      case 115: // 'F4'
        ventiler_ecriture();
        break;
        
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#keypress : ' + e);
  }
}


/****************************************************
 ****************************************************/
function ventiler_ecriture() {
  try {
    var v = get_tree().view;
    var id = v.selection.currentIndex;
    var date = v.getCellText(id,'date');
    var day = v.getCellText(id,'day');
    var month = v.getCellText(id,'month');
    var year = v.getCellText(id,'year');
    var compte = v.getCellText(id,'compte');
    var libelle = v.getCellText(id,'libelle');
    var num = v.getCellText(id,'num');
    var base = v.getCellText(id,'base');
    var debit = v.getCellText(id,'debit').replace(',','.');
    if (isEmpty(debit)) debit = '0';
    var credit = v.getCellText(id,'credit').replace(',','.');
    if (isEmpty(credit)) credit = '0';
    var url = "chrome://opensi/content/compta/user/autres/importbank/ventilation.xul?" + cookie();
    url += "&date=" + date;
    url += "&day=" + day;
    url += "&month=" + month;
    url += "&year=" + year;
    url += "&compte=" + compte;
    url += "&libelle=" + libelle;
    url += "&debit=" + debit;
    url += "&credit=" + credit;
    url += "&num=" + num;
    url += "&id=" + id;
    url += "&base=" + base;
    window.openDialog(url,'ventilation','chrome,modal');
    select_row(id);
    document.getElementById('input_compte').focus();
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#ventiler_ecriture : ' + e);
  }
}

function supprimer(id) {
  try {
    get_root().removeChild(get_child(parseInt(id)));
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#supprimer : ' + e);
  }
}

function ajouter(id,date,day,month,year,compte,libelle,debit,credit,num,base) {
  try {
    
    var child = dsource.getAnonymousNode();
    child.addTargetOnce(targetname('input_date'),date);
    child.addTargetOnce(targetname('input_day'),day);
    child.addTargetOnce(targetname('input_month'),month);
    child.addTargetOnce(targetname('input_year'),year);
    child.addTargetOnce(targetname('input_compte'),compte);
    child.addTargetOnce(targetname('input_libelle'),libelle);
    child.addTargetOnce(targetname('input_debit'),debit);
    child.addTargetOnce(targetname('input_credit'),credit);
    child.addTargetOnce(targetname('input_num'),num);
    child.addTargetOnce(targetname('input_base'),base);
    child.addTargetOnce(targetname('input_prop'),'enabled');
    get_root().addChildAt(child,id);

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#ajouter : ' + e);
  }
}

/****************************************************
 ****************************************************/
function reprise_lib_compte() {
  try {
    if (focus_input == 'input_libelle') {
      var libelle_compte = document.getElementById('libelle_compte').value;
      document.getElementById('input_libelle').value = libelle_compte;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#reprise_num_compte : ' + e);
  }
}

/****************************************************
 *  selectionne un ligne dans l'arbre.
 *  @param index : l'index de la ligne de l'arbre  slectionner
 ****************************************************/
function select_row(index) {
  try {
    var tree = get_tree();
    if (tree.view != null) {
      tree.view.selection.select(index);
      tree.treeBoxObject.ensureRowIsVisible(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#select_row : ' + e);
  }
}

/****************************************************
 *  slection de la premire ligne de l'arbre
 ****************************************************/
function select_begin(){
  select_row(0);
}

/****************************************************
 *  slection de la dernire ligne de l'arbre
 ****************************************************/
function select_end(){
  try {
    var v = get_tree().view;
    select_row(v.rowCount - 1);
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#select_end : ' + e);
  }
}

/****************************************************
 *  slection d'une ligne 10 lignes au dessus de la ligne slectionne
 ****************************************************/
function select_up(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 10;
    if (index < 0) {
      select_begin();
    } else {
      while (v.isSeparator(index)) index--;
      if (index >= 0) {
        select_row(index);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#select_up : ' + e);
  }
}

/****************************************************
 *  slection d'une ligne 10 lignes en dessous de la ligne slectionne
 ****************************************************/
function select_down(){
  try {
    var v = get_tree().view;
    var rc = v.rowCount;
    var index = v.selection.currentIndex + 10 ;
    if (index >= rc) {
      select_end();
    } else {
      while (v.isSeparator(index)) index++;
      if (index < rc) {
        select_row(index);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#select_down : ' + e);
  }
}

/****************************************************
 *  slection de la ligne prcdente  la ligne slectionne
 ****************************************************/
function select_prev(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 1;
    if (index < 0) return false;
    while (v.isSeparator(index)) index--;
    if (index >= 0) {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#select_prev : ' + e);
  }
}

/****************************************************
 *  slection de la ligne suivante  la ligne slectionne
 ****************************************************/
function select_next(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex + 1;
    if (index >= v.rowCount) return false;
    while ((index < v.rowCount) && (v.isSeparator(index))) index++;
    if (index < v.rowCount ) {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#select_next : ' + e);
  }
}

/****************************************************
 *  focus sur la zone de saisie prcdant la zone
 *  ayant couramment le focus.
 ****************************************************/
function focus_prev(){
  
  try {
  
    var f = focus_input;
    var t = document.getElementById(f);
    switch (f) {
      case 'input_libelle':
        if (t.value != anc_value) {
          if(change_libelle()) {
            f = 'input_compte';
          } else {
            f = 'input_libelle';
          }
        } else {
          f = 'input_compte';
        }
        break;
    }
    document.getElementById(f).focus();

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#focus_prev : ' + e);
  }

}

/****************************************************
 *  focus sur la zone de saisie suivant la zone
 *  ayant couramment le focus.
 ****************************************************/
function focus_next(){
  
  try {
  
    var f = focus_input;
    var t = document.getElementById(f);
    switch (f) {
      case 'input_compte':
        if (t.value != anc_value) {
          if (change_compte()) {
            f = 'input_libelle';
          } else {
            f = 'input_compte';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_compte';
        } else {
          f = 'input_libelle';
        }
        break;
      case 'input_libelle':
        if (t.value != anc_value) {
          if (change_libelle()) {
            f = 'input_compte';
            select_next();
          } else {
            f = 'input_libelle';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_libelle';
        } else {
          f = 'input_compte';
          select_next();
        }
        break;
    }
    document.getElementById(f).focus();

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#focus_next : ' + e);
  }

}

/****************************************************
 *  Excut lorsqu'une zone de saisie a t modifie
 *  
 *  @param id : l'identifiant de la zone de saisie.
 ****************************************************/
function change_field(id){
  try{
    var t = document.getElementById(id);
    var child =  get_child(get_tree().currentIndex);
    var value = t.value;
    child.addTargetOnce(targetname(id),value);
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#change_field : ' + e);
  }
}

/****************************************************
 *  Excut lorsque le numero de compte a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_compte() {
  
  try {

    var t = document.getElementById('input_compte');
//    var comptes = document.getElementById('liste_comptes');
    if (isEmpty(t.value)) {
      return false;
    }
    if (force) {
      maj_aff_compte(t,false);
      force = false;
    } else {
      if (t.value == '*') t.value = ' ';
      var compte = maj_aff_compte(t,true);
      if (isEmpty(compte)) return false;
      t.value = compte;
    }

    
    change_field('input_compte');

    var child =  get_child(get_tree().currentIndex);
    child.addTargetOnce(targetname('input_prop'),'enabled');

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#change_compte : ' + e);
  }

}

/****************************************************
 *  Excut lorsque le libell a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_libelle() {
  
  try {
    var t = document.getElementById('input_libelle');
    if (isEmpty(t.value)) {
      return false;
    }
    change_field('input_libelle');

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#change_libelle : ' + e);
  }

}

function ok() {
  try { 
    listeecritures = "";
    updateDatabase('debit');
    updateDatabase('credit');
    refreshEcritures(listeecritures); 
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#ok : ' + e);
  }
}

function refreshEcritures(listeecr){
  
  try {
  
    dsource.deleteRecursive("http://www.opensi.org/compta/bank");
    var datasource = dsource.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource);

  	var paramlist = "&Page=Compta/GetRDF/suite_banque.tmpl&ContentType=xml";
    paramlist += "&Ecritures=" + escape(listeecr);
    paramlist += "&Code_Journal=" + ParamValeur("Code_Journal");
    dsource = new RDFDataSource(); 
    
    load_rdf_async('transactions',getUrlOpeneas(paramlist),init_tree);

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#ok : ' + e);
  }

}

/****************************************************
 * Ajout de l'criture courante dans la base
 ****************************************************/

function updateDatabase(type_montant) {

  if (type_montant != 'debit' && type_montant != 'credit') {
    recup_erreur("erreur dans compta/user/autres/traitementbank.js#updateDatabase :"
                 + " paramtre <type_montant> invalide : '" + type_montant + "'");
    return false;
  }

  try {

    var v = get_tree().view;
    var operations = '';
    var root = get_root();
    var children = root.getChildren();
    var v = get_tree().view;
    var periode = 0;
    solde = 0;

    while (children.hasMoreElements()) {
      var child = children.getNext();
      var index = root.getChildIndex(child) - 1;
      var id = v.getCellText(index,'id');
      if (!isEmpty(listeecritures)) listeecritures += ',';
      listeecritures += id;
      var mois = v.getCellText(index,'month');
      var annee = v.getCellText(index,'year').substring(2,4);
      var periodeecr = mois + annee;
      if (periode == 0) periode = periodeecr;
      if (periodeecr == periode) {
        var op = get_operation(index,type_montant);
        if (! isEmpty(op)) {
          if (! isEmpty(operations)) operations += ';';
          operations += op;
        }
      } else {

        var base = v.getCellText(index,'base');
        nouvelleEcriture(operations,periode,base);

        periode = periodeecr;
        solde = 0;
        var op = get_operation(index,type_montant);
        if (isEmpty(op)) {
          operations = '';
        } else {
          operations = op;
        }

      }
    }

    nouvelleEcriture(operations,periode,base);
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#updateDatabase : ' + e);
  }

}

function nouvelleEcriture(listeop,periode,base) {
  
  if (isEmpty(listeop)) return false;
  
  try {
    var operations = listeop;
    var debit = 0;
    var credit = 0;
//    operations +="Num_Ligne:,";
//    operations += "Date_Op:" + dateop + ",";
//    operations += "Numero_Compte:" + compte + ",";
//    operations += "Type:,";
//    operations += "Raccourci:,";
//    operations += "Libelle:" + libcompte(compte) + ",";
//    operations += "Contrepartie:,";
//    operations += "Date_Echeance:,";
    if (solde > 0) {
      credit = format(solde,2,'',0);
    } else {
      debit = format(0 - solde,2,'',0);
    }
//    operations += "Montant_D:" + debit + ",";
//    operations += "Montant_C:" + credit + ",";
//    operations += "Num_Piece:";
//
////        var corps = '&Page=Compta/UpdateDatabase/update.tmpl&ContentType=none&' + cookie();
    var corps = '&Page=Compta/UpdateDatabase/update.tmpl&' + cookie();
    corps += '&req=bank';
    corps += '&Base=' + base;
    corps += '&code_journal=' + ParamValeur('Code_Journal');
    corps += '&Periode=' + periode;
    corps += '&Date_op=' + dateop;
    corps += '&compte=' + compte;
    corps += '&libelle=' + libcompte(compte);
    corps += '&credit=' + credit;    
    corps += '&debit=' + debit;    
    corps += '&operations=' + escape(operations);
    var p = requeteHTTP(corps);

    if (p.status == "0") return false;
    
    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#nouvelleEcriture : ' + e);
  }

}

function get_operation(index,type_montant){

  if (type_montant != 'debit' && type_montant != 'credit') {
    recup_erreur("erreur dans compta/user/autres/traitementbank.js#get_operation :"
                 + " paramtre <type_montant> invalide : '" + type_montant + "'");
    return false;
  }

  try {
  
    var v = get_tree().view;
    var day = v.getCellText(index,'day');
    var month = v.getCellText(index,'month');
    var year = v.getCellText(index,'year');
    dateop = get_date(day,month,year);
    var numcompte = v.getCellText(index,'compte');
    var raccourci = '';
    var libelle = v.getCellText(index,'libelle');
    var contrepartie = compte;
    var debit = v.getCellText(index,'debit').replace(rExp,'');
    var credit = v.getCellText(index,'credit').replace(rExp,'');
    var echeance = '';
    var piece = v.getCellText(index,'num');

    var operation = '';

    
    if (isEmpty(debit) && isEmpty(credit)) {
      var num_ecr = '';
      var child =  get_child(index);
      var root = get_root();
      root.removeChild(child);
    } else {
      operation = "Num_Ligne:,";
      operation += "Date_Op:" + dateop + ",";
      operation += "Numero_Compte:" + numcompte + ",";
      operation += "Type:,";
      operation += "Raccourci:" + raccourci + ",";
      operation += "Libelle:" + libelle + ",";
      operation += "Contrepartie:" + contrepartie + ",";
      operation += "Date_Echeance:" + echeance + ",";
      if (isEmpty(debit)) {
        debit = 0;
      } else {
        if (type_montant != 'debit') {
          return '';
        }
        debit = parseFloat(debit);
      }
      operation += "Montant_D:" + debit + ",";
      if (isEmpty(credit)) {
        credit = 0;
      } else {
        if (type_montant != 'credit') {
          return '';
        }
        credit = parseFloat(credit);
      }
      operation += "Montant_C:" + credit + ",";
      operation += "Num_Piece:" + piece;
    }
    
    solde = solde + parseFloat(debit) - parseFloat(credit);
    
    return operation;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#get_operation : ' + e);
  }

}

function libcompte(numcompte) {

  try {
    
    var paramlist = cookie() + "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
    paramlist += "&Numero_Compte=" + numcompte;
  
    var p = requeteHTTP(paramlist);
  
    if (p.status == "0") return false;
    
    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
      return '';
    } else {
      var contenu=p.responseXML;
      var session = contenu.documentElement;
      if (session.getElementsByTagName('numero').length  == 0 ) {
        return '';
      } else {
        var l = session.getElementsByTagName('libelle')[0];
        return l.firstChild.data;
      }
    }
        
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/traitementbank.js#libcompte : ' + e);
  }

}