/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/util/rechcompte.xul>
 * @include chrome://opensi/content/libs/verif.js
 * @include chrome://opensi/content/libs/util.js
 * @include chrome://libopensi/content/load_rdf.js
 *
 */
var force = false;
var rExp = / /gi;


function init() {
  var x = (screen.width / 2) - 400;
  var y = (screen.height / 2) - 200;
  window.resizeTo(700,300);
  window.moveTo(x,y);
//  var paramlist = "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
//  load_rdf('liste_comptes', getUrlOpeneas(paramlist)); 
  var paramlist2 = "&Page=Compta/GetRDF/liste_journaux.tmpl&ContentType=xml";
  load_rdf('journaux', getUrlOpeneas(paramlist2));
  var solde = parseFloat(ParamValeur('solde'));
  if (solde > 0) {
    document.getElementById('montant').value = format(solde,2,' ',0);    
    document.getElementById('nom_montant').value = 'Crdit';
  } else {
    solde = - solde;
    document.getElementById('montant').value = format(solde,2,' ',0);    
    document.getElementById('nom_montant').value = 'Dbit';
  }
  document.getElementById('libelle').value = "Diffrence lettrage";
  document.getElementById('contrepartie').focus();
}


function ok() {
  
  try {

    var contrepartie = document.getElementById('contrepartie');  
    if (isEmpty(contrepartie.value)) {
      contrepartie.focus();
      return false;
    }
    var numcpt = belongs(contrepartie.value); 
    if (isEmpty(numcpt)) {
      recherche_compte();
      ok();
    } else {
      contrepartie.value = numcpt;
      var journaux = document.getElementById('journaux');
      switch(journaux.selectedIndex) {
        case -1:
          var journal = journaux.value;
          if (isEmpty(journal)) {
            journaux.focus();
          } else {
            var nom_journal = labelJournal(journal);
            if (isEmpty(nom_journal)) {
              msg = "Le journal "+ journal +" n'existe pas. ";
              msg += "Veuillez en slectionner un dans la liste.";
              alert(msg);
              journaux.value = "";
              journaux.focus();
            } else {
              journaux.value = nom_journal;
              validEcriture(contrepartie.value,journal);
            }
          }
          break;
//        case 0:
//          break;
        default:
          var journal = journaux.selectedItem.value;
          validEcriture(contrepartie.value,journal);
          break;
      }
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/lettrage.js#ok : ' + e);
  }

}

function validEcriture(contrepartie,journal) {

  try {

    var debut_exo = parseInt(get_cookie('Premier_Mois_Exercice'));
    var fin_exo = parseInt(get_cookie('Dernier_Mois_Exercice'));
    var date = document.getElementById('date');
    if (isEmpty(date.value)) {
      date.focus();
      return false;
    }
    if (isNaN(parseInt(date.value))) {
      alert("mauvais format de date ('JJMMAA')");
      date.value = '';
      date.focus();
      return false;
    }
    if (date.value.length != 6) {
      alert("mauvais format de date ('JJMMAA')");
      date.value = '';
      date.focus();
      return false;
    }
    var strjour = date.value.substr(0,2);
    var strmois = date.value.substr(2,2);
    var strannee = date.value.substr(4,2);
    var jour = parseIntBis(strjour);
    var mois = parseIntBis(strmois);
    var annee = parseIntBis(strannee);
    var moisannee = (2000 + annee) * 12 + mois;
    if ((jour < 1) || (jour > nb_jours(mois,annee))) {
      alert("Date incorrecte");
      date.value = '';
      date.focus();
      return false;
    }
    if ((moisannee < debut_exo) || (moisannee > fin_exo)) {
      alert("La date est en dehors de la priode de l'exercice !");
      date.value = '';
      date.focus();
      return false;
    }
    var dateval = '20' + strannee + ':' + strmois + ':' + strjour;
    var raccourci = document.getElementById('raccourci');
    var libelle = document.getElementById('libelle');
    if (isEmpty(libelle.value)) {
      libelle.focus();
      return false;
    }
    
    var ll = ParamValeur('Lettre');
    var corps = '&Page=Compta/UpdateDatabase/update.tmpl&ContentType=none&req=ecr_lettrage&';
    corps += cookie();
    corps += '&Num_Compte=' + ParamValeur('NumCompte');
    corps += '&Lettre=' + ll;
    corps += '&solde=' + ParamValeur('solde');
    corps += '&Date=' + dateval;
    corps += '&Raccourci=' + raccourci.value;
    corps += '&Libelle=' + libelle.value;
    corps += '&Contrepartie=' + contrepartie;
    corps += '&Code_Journal=' + journal;
  
    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,nope,ll);
    window.opener.lettrer(ll);
    window.close();

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/lettrage.js#validEcriture : ' + e);
  }

}

function validEcriture2(httpRequest,ll) {
  try {
    window.opener.lettrer(ll);
    window.close();
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/lettrage.js#validEcriture2 : ' + e);
  }
}

function keypress(e) {
  switch (e.keyCode) {
    case 13: // <Enter>
      ok();
      break;
  }
}

function keypresscompte(e) {
  try {
    switch (e.keyCode) {
      case 13: // <Enter>
        document.getElementById('journaux').focus();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/lettrage.js#keypresscompte : ' + e);
  }
}

function labelJournal(journal){
  try {
    var tab_journaux = document.getElementById('journaux').getElementsByTagName('menuitem');
    for (i=1;i<tab_journaux.length;i++) {
      var tab_journal = tab_journaux[i];
      if (journal.toUpperCase() == tab_journal.value.toUpperCase()) 
        return tab_journal.label;
      if (journal.toUpperCase() == tab_journal.label.toUpperCase()) 
        return tab_journal.label;
    }
    return '';
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/lettrage.js#labelJournal : ' + e);
  }
}

function blurcompte(t) {
  try {
    var num_compte = t.value;
    if (isEmpty(num_compte)) {
      t.focus();
    } else {
      var numcpt = belongs(num_compte);
      if (isEmpty(numcpt)) {
        recherche_compte();
      } else {
        t.value = numcpt;
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/lettrage.js#blurcompte : ' + e);
  }
}

/****************************************************
 *  Effectue une recherche de compte
 *  @param t la zone de saisie  affecter.
 ****************************************************/
function recherche_compte(){
  try {
    var id = 'contrepartie';
    var compte = document.getElementById(id).value;
    var url = "chrome://opensi/content/compta/util/rechcompte.xul?" + cookie();
    window.openDialog(url,'rechcompte','chrome,modal',compte,id,false);
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/lettrage.js#recherche_compte : ' + e);
  }  
}

function belongs(num_compte) {

  try {

    var compte = num_compte;
    var paramlist = cookie() + "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
    paramlist += "&Numero_Compte=" + compte;

    var p = requeteHTTP(paramlist);

    if (p.status == "0") return false;

    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
      return false;
    } else {
      var contenu=p.responseXML;
      var session = contenu.documentElement;
      var comptes = session.getElementsByTagName('numero');
      if (comptes.length  == 1 ) {
        return comptes[0].firstChild.data;
      } else {
        return '';
      }
    }
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/lettrage.js#belongs : ' + e);
    return false;
  }

}