/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/user/creer_exercice.xul>
 * @include chrome://opensi/content/libs/util.js
 * @include chrome://opensi/content/libs/verif.js
 *
 */

function init() {
	try {	
		var corps = cookie() + "&Page=Compta/GetLastExercice.tmpl&ContentType=xml";
    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,suiteInit);
	} catch (e) {
    recup_erreur('erreur dans compta/user/creer_exercice.js#init : ' + e);
  }
}

function suiteInit(httpRequest) {
  
  try {
		
  	if (httpRequest.status != "200") {
    	alert("Rception erreur " + httpRequest.status);
  	} 
		else {
			var contenu = httpRequest.responseXML;
			var lastexo = contenu.documentElement;
		
			var debut = lastexo.getAttribute('debut_exercice_format');
			var fin = lastexo.getAttribute('fin_exercice_format');
			var base = lastexo.getAttribute('nom_base');
			document.getElementById("Ancien_Exercice").value = "Ancien Exercice: Du "+ debut +" au "+ fin;
			
			var paramlist = "&Page=Compta/GetRDF/liste_journaux_an.tmpl&ContentType=xml&Base="+ base;
    	load_rdf_async("JournalAN", getUrlOpeneas(paramlist), selectJournalAN);
		}
	
		document.getElementById("Date_Fin").focus();
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/creer_exercice.js#suiteInit : ' + e);
  }
}

function selectJournalAN() {
	try {
    document.getElementById('JournalAN').selectedIndex = 0;
	} catch (e) {
    recup_erreur('erreur dans compta/user/creer_exercice.js#selectJournalAN : ' + e);
  }
}

function createExercice() {
	try {
		document.getElementById('progression').collapsed = false;
		setTimeout('createExercicebis()',100);
	} catch (e) {
    recup_erreur('erreur dans compta/user/creer_exercice.js#createExercice : ' + e);
  }
}

function createExercicebis() {
	try {
		var date_fin = document.getElementById('Date_Fin').value;	
		var journal_an = document.getElementById('JournalAN').value;

		if (isEmpty(journal_an)) {
			alert('Impossible de crer l\'exercice aucun journal d\'A Nouveau disponible !');
  		document.getElementById('progression').collapsed = true;
		}	else if (isEmpty(date_fin)) {
			alert('Vous devez spcifier une date de fin d\'exercice !');
			document.getElementById('progression').collapsed = true;
  	}	else if (!isDate(date_fin)) {
			alert('Date incorrecte !');
  		document.getElementById('progression').collapsed = true;
		}	else {

			date_fin = prepareDateJava(date_fin);

  		var corps = cookie() + "&Page=Compta/UpdateDatabase/CreerExercice.tmpl&ContentType=xml";
      corps += "&Fin_Exercice="+ date_fin;
      corps += "&JournalAN="+ journal_an;

      var httpRequest = new XMLHttpRequest();
      requeteHTTP(corps,httpRequest,suiteCreateExercice);
    }
	} catch (e) {
    recup_erreur('erreur dans compta/user/creer_exercice.js#createExercicebis : ' + e);
  }
}

function suiteCreateExercice(httpRequest) {

	try {

			var cloture = 1;

  		if (httpRequest.status != "200") {
    		alert("Rception erreur " + httpRequest.status);
  		} 
			else {				
				var contenu = httpRequest.responseXML.documentElement;
					
				alert(contenu.getAttribute('msg'));

				cloture = parseIntBis(contenu.getAttribute('ok'));
				if (cloture==0) {
					document.getElementById('progression').collapsed = true;
					document.getElementById('Date_Fin').focus();
				}
			}

			if (cloture==1) {
				var page  = "chrome://opensi/content/compta/user/menu_dossier.xul?" + cookie();
				page += "&Libelle=" + parent.document.getElementById("nom_dossier").value;
  			window.location = page;
			}
		  document.getElementById('progression').collapsed = true;

	} catch (e) {
    recup_erreur('erreur dans compta/user/creer_exercice.js#suiteCreateExercice : ' + e);
  }

}

function retour_exercice() {
	try {
  	var page = "chrome://opensi/content/compta/user/menu_dossier.xul?" + cookie();
  	page += "&Libelle=" + parent.document.getElementById("nom_dossier").value;
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans compta/user/creer_exercice.js#retour_exercice : ' + e);
  }
}