/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/user/menu_dossier.xul>
 * @include chrome://libopensi/content/load_rdf.js
 * @include chrome://opensi/content/libs/util.js
 *
 */

var paramlist = "&Page=Compta/GetRDF/Dossier.tmpl&ContentType=xml";

function init() {
  try {
    load_rdf_async('box1', getUrlOpeneas(paramlist),focus_tree);
    parent.document.getElementById("nom_dossier").value = ParamValeur('Libelle');
    parent.document.getElementById("date_exercice").value = "";
  } catch (e) {
    recup_erreur('erreur dans compta/user/menu_dossier.js#init : ' + e);
  }
}
  
function focus_tree(ds) {
  try {
    var v = document.getElementById('box1');
    v.focus();
    v.view.selection.select(0);
  } catch (e) {
    recup_erreur('erreur dans compta/user/menu_dossier.js#focus_tree : ' + e);
  }
}

function nouvel_exercice() {
  try {
		if (nb_exos_ouverts()<2) {			  
  		var page = "chrome://opensi/content/compta/user/creer_exercice.xul?" + cookie() ;
  	  window.location = page;
	  } else {
		  alert("Impossible d'ouvrir un nouvel exercice !\n"
            + "Vous devez cloturer l'exercice prcdent");
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/menu_dossier.js#nouvel_exercice : ' + e);
  }
}

function ok() {
  
  try {
  
    var v = document.getElementById('box1').view;
    var base = v.getCellText(v.selection.currentIndex,'base');
    var cloturable = v.getCellText(v.selection.currentIndex,'cloturable');
    var writeable = v.getCellText(v.selection.currentIndex,'writeable');
    var debut_exercice = v.getCellText(v.selection.currentIndex,'debut_exercice');
    var fin_exercice = v.getCellText(v.selection.currentIndex,'fin_exercice');
    var num_exercice = v.getCellText(v.selection.currentIndex,'num_exercice');
    var dates = v.getCellText(v.selection.currentIndex,'dates');
    set_cookie('Writeable',writeable);
    set_cookie('Base',base);
    set_cookie('Debut_Exercice',debut_exercice);
    set_cookie('Fin_Exercice',fin_exercice);
    set_cookie('Num_Exercice',num_exercice);
    set_cookie('Cloturable',cloturable);
    //var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie() ;
		var page = "chrome://opensi/content/compta/user/control_coherence.xul?" + cookie();
    page += "&Dates=Exercice+" + dates;
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans compta/user/menu_dossier.js#ok : ' + e);
  }

}

function keypress(e) {
  try {
    switch(e.keyCode){
      case 13:
        ok();
        break;
      case 78:
        nouvel_exercice();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/menu_dossier.js#keypress : ' + e);
  }
}