/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/util/rechecriture.xul>
 * @include chrome://opensi/content/libs/verif.js
 * @include chrome://opensi/content/libs/util.js
 * @include chrome://libopensi/content/load_rdf.js
 *
 */
 
var rExp = / /gi;

function init() {
  try {
    var paramlist = "&Page=Compta/GetRDF/liste_journaux.tmpl&ContentType=xml";
    load_rdf('journaux', getUrlOpeneas(paramlist));
    document.getElementById('compte').focus();
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#init : ' + e);
  }
}

function labelJournal(journal){
  try {
    var tab_journaux = document.getElementById('journaux').getElementsByTagName('menuitem');
    for (i=1;i<tab_journaux.length;i++) {
      var tab_journal = tab_journaux[i];
      if (journal.toUpperCase() == tab_journal.value.toUpperCase()) 
        return tab_journal.label;
      if (journal.toUpperCase() == tab_journal.label.toUpperCase()) 
        return tab_journal.label;
    }
    return '';
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#labelJournal : ' + e);
  }
}

function ok() {

  try {

    var page = "chrome://opensi/content/compta/user/saisie/saisie.xul?rech=true&" + cookie();

    var compte = document.getElementById('compte').value;
    var toutvide = isEmpty(compte);
    
    page += "&compte=" + compte;

    switch(document.getElementById('debitbox').selectedItem.id){
      case 'isdebitexact':
        var debit = document.getElementById('debit').value;
        page += "&debit=" + debit.replace(rExp,'');
        toutvide = toutvide && isEmpty(debit);
        break;
      case 'isdebitinter':
        var debitinf = document.getElementById('debitinf').value;
        var debitsup = document.getElementById('debitsup').value;
        page += "&debitinf=" + debitinf.replace(rExp,'');
        page += "&debitsup=" + debitsup.replace(rExp,'');
        toutvide = toutvide && isEmpty(debitinf) && isEmpty(debitsup);
        break;
    }

    switch(document.getElementById('creditbox').selectedItem.id){
      case 'iscreditexact':
        var credit = document.getElementById('credit').value;
        page += "&credit=" + credit.replace(rExp,'');
        toutvide = toutvide && isEmpty(credit);
        break;
      case 'iscreditinter':
        var creditinf = document.getElementById('creditinf').value;
        var creditsup = document.getElementById('creditsup').value;
        page += "&creditinf=" + creditinf.replace(rExp,'');
        page += "&creditsup=" + creditsup.replace(rExp,'');
        toutvide = toutvide && isEmpty(creditinf) && isEmpty(creditsup);
        break;
    }

    switch(document.getElementById('datebox').selectedItem.id){
      case 'isdateexact':
        var date = document.getElementById('date');
        if (isPeriode(date.value)) {
          page += "&date=" + date.value;
        } else if (! isEmpty(date.value)) {
          alert('Date invalide');
          date.focus();
          return false;
        }
        toutvide = toutvide && isEmpty(date.value);
        break;
      case 'isdateinter':
        var dateinf = document.getElementById('dateinf');
        var datesup = document.getElementById('datesup');
        if (isPeriode(dateinf.value)) {
          page += "&dateinf=" + dateinf.value;
        } else if (! isEmpty(dateinf.value)) {
          alert('Date invalide');
          dateinf.focus();
          return false;
        }
        if (isPeriode(datesup.value)) {
          page += "&datesup=" + datesup.value;
        } else if (! isEmpty(datesup.value)) {
          alert('Date invalide');
          datesup.focus();
          return false;
        }
        toutvide = toutvide && isEmpty(dateinf.value) && isEmpty(datesup.value);
        break;
    }

    var libelle = document.getElementById('libelle').value;
    page += "&libelle=" + libelle;
    var piece = document.getElementById('piece').value;
    page += "&piece=" + piece;

    var journaux = document.getElementById('journaux');
    var journal = '';
    switch(journaux.selectedIndex) {
      case -1:
        journal = journaux.value;
        if (isEmpty(journal)) {
        } else {
          var nom_journal = labelJournal(journal);
          if (isEmpty(nom_journal)) {
          } else {
            journaux.value = nom_journal;
            journal = journaux.selectedItem.value;
          }
        }
        break;
      default:
        journal = journaux.selectedItem.value;
        break;
    }
    page += "&journal=" + journal;
    
    toutvide = toutvide && isEmpty(libelle) && isEmpty(piece) && isEmpty(journal);

    if (toutvide) {
      alert("Vous devez spcifier au moins un critre de recherche");
      document.getElementById('compte').focus();
    } else {
      window.location = page;
    }
    
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#ok : ' + e);
  }

}

function selectradio(t){
  try {
    switch(t.id) {
      case 'debitbox':
        switch(t.selectedItem.id){
          case 'isdebitexact':
            var tb = document.getElementById('debit');
            tb.readonly = false;
            tb.focus();
            tb = document.getElementById('debitinf');
            tb.value = '';
            tb.readonly = true;
            tb = document.getElementById('debitsup');
            tb.value = '';
            tb.readonly = true;
            break;
          case 'isdebitinter':
            var tb = document.getElementById('debitinf');
            tb.readonly = false;
            tb.focus();
            document.getElementById('debitsup').readonly = false;
            tb = document.getElementById('debit');
            tb.value = '';
            tb.readonly = true;
            break;
        }
        break;
      case 'creditbox':
        switch(t.selectedItem.id){
          case 'iscreditexact':
            var tb = document.getElementById('credit');
            tb.readonly = false;
            tb.focus();
            tb = document.getElementById('creditinf');
            tb.value = '';
            tb.readonly = true;
            tb = document.getElementById('creditsup');
            tb.value = '';
            tb.readonly = true;
            break;
          case 'iscreditinter':
            var tb = document.getElementById('creditinf');
            tb.readonly = false;
            tb.focus();
            document.getElementById('creditsup').readonly = false;
            tb = document.getElementById('credit');
            tb.value = '';
            tb.readonly = true;
            break;
        }
        break;
      case 'datebox':
        switch(t.selectedItem.id){
          case 'isdateexact':
            var tb = document.getElementById('date');
            tb.readonly = false;
            tb.focus();
            tb = document.getElementById('dateinf');
            tb.value = '';
            tb.readonly = true;
            tb = document.getElementById('datesup');
            tb.value = '';
            tb.readonly = true;
            break;
          case 'isdateinter':
            var tb = document.getElementById('dateinf');
            tb.readonly = false;
            tb.focus();
            document.getElementById('datesup').readonly = false;
            tb = document.getElementById('date');
            tb.value = '';
            tb.readonly = true;
            break;
        }
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/selectradio.js#ok : ' + e);
  }
}

function keypress(e) {
  try {
    switch (e.keyCode) {
      case 13: // <Enter>
        ok();
        break;
      case 123: // F12
        recherche_compte();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#keypress : ' + e);
  }
}

function blurmontant(t) {
  try {
    var v = eval(t.value.replace(rExp,''));
    if (isNaN(v)) {
      t.value = '';
    } else {
      t.value = format(eval(v),2,' ',0);
    }
  } catch (e) {
    t.value = '';
  }
}

/****************************************************
 *  Effectue une recherche de compte
 ****************************************************/
function recherche_compte(){
  try {
    var compte = document.getElementById('compte').value;
    var url = "chrome://opensi/content/compta/util/rechcompte.xul?" + cookie();
    window.openDialog(url,'rechcompte','chrome,modal',compte,'compte',false);  
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#recherche_compte : ' + e);
  }
}

function isPeriode(p) {
  try {
    if (! isFinite(p)) return false;
    if (p.length != 6) return false;
    var jour = eval(p.substring(0,2));
    var mois = eval(p.substring(2,4));
    var annee = eval(p.substring(4,6));
    var aux = (annee + MODULO) % 100 ;
    annee = aux + BASE_CALENDRIER ;
    var date = annee * 12 + mois;
    var debut_exercice = parseInt(get_cookie('Premier_Mois_Exercice'));  
    var fin_exercice = parseInt(get_cookie('Dernier_Mois_Exercice'));  
    if (date < debut_exercice ) return false;
    if (date > fin_exercice ) return false;
    if (jour < 0) return false;
    if (jour > nb_jours(mois,annee)) return false;
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#isPeriode : ' + e);
  }
}