/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/util/regles_banque.xul>
 * @include chrome://opensi/content/util.js
 *
 */

var dossier;
var base;
var dsource;

/*****************************************************
 *  @return l'id de l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree_id(){
  return 'tree_regles_banque';
}

/*****************************************************
 *  @return le pointeur vers l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree(){
  try {
    return document.getElementById(get_tree_id());
  } catch (e) {
    recup_erreur('erreur dans compta/util/regles_banque.js#get_tree : ' + e);
  }
}

function get_root() {
  try {
    return dsource.getNode("http://www.opensi.org/compta/regles");
  } catch (e) {
    recup_erreur('erreur dans compta/util/regles_banque.js#get_root : ' + e);
  }
}

function init() {
	try {
//alert('init');

    paramlist = getUrlOpeneas('') + "?Page=Compta/GetRDF/regles_banque.tmpl&ContentType=xml";
    load_tree(paramlist); 

	} catch (e) {
    recup_erreur('erreur dans compta/util/regles_banque.js#init : ' + e);
  }
}

/****************************************************
 *  Chargement des critures dans l'arbre.
 *  @param dsUrl : l'URL de la source de donnes RDF.
 ****************************************************/
function load_tree(dsUrl) {
//alert('load_tree');
  try {

//    pgload().value = 10;

    // initialise la source de donnes de l'arbre.
    dsource = new RDFDataSource(); 
    
    // Gnre une source de donnes  partir de l'URL dfinie en paramtres,
    // et appelle la fonction init_tree() une fois la source charge.
    load_rdf_async(get_tree_id(), dsUrl, init_tree);   
    
  } catch (e) {
    recup_erreur('erreur dans compta/util/regles_banque.js#load_tree' + e);
  }
  
}

/****************************************************
 *  Chargement de l'arbre depuis la source.
 *  @param dsource2 : la source du RDF
 ****************************************************/
function init_tree(dsource2){
//alert('init_tree');
  try {
    
    dsource.deleteRecursive("http://www.opensi.org/compta/regles");
    var datasource = dsource.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource);

    dsource2.copyAllToDataSource(dsource);

    var datasource2 = dsource2.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource2);
    var datasource = dsource.getRawDataSource();
    get_tree().database.AddDataSource(datasource);
    
  } catch (e) {
    recup_erreur('erreur dans compta/util/regles_banque.js#init_tree' + e);
  }

}

function reporter() {
  
  try {
  
    var id_select = get_tree().currentIndex;
    var v = get_tree().view;

    if (id_select == -1) return false;
      
    var type = v.getCellText(v.selection.currentIndex,'type');
    
    switch (type) {
      case 'criteres' :
        document.getElementById('rowregle').collapsed = true;
        var libelle = v.getCellText(v.selection.currentIndex,'libelle');
        document.getElementById("input_libelle").value = libelle;
        var credit = v.getCellText(v.selection.currentIndex,'credit');
        var debit = v.getCellText(v.selection.currentIndex,'debit');
        if (isEmpty(credit)) {
         document.getElementById("input_montant").value = debit;
         document.getElementById("input_type").selectedIndex = 0;
        } else {
         document.getElementById("input_montant").value = credit;
         document.getElementById("input_type").selectedIndex = 1;
        }
        document.getElementById('rowcriteres').collapsed = false;
        break;
      case 'regle' :
        document.getElementById('rowcriteres').collapsed = true;
        document.getElementById('rowregle').collapsed = false;
        var compte = v.getCellText(v.selection.currentIndex,'compte');
        document.getElementById("input_compte").value = compte;
        var ratio = v.getCellText(v.selection.currentIndex,'ratio');
        document.getElementById("input_ratio").value = ratio;
        break;
    }

  } catch(e) {
    recup_erreur('erreur dans compta/util/regles_banque.js#do_reporter : ' + e);
  }
    
}



function keypress(e) {
	try {
		switch (e.keyCode) {
    }
	} catch (e) {
    recup_erreur('erreur dans compta/util/regles_banque.js#keypress : ' + e);
  }
}

