/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var devis_id;

function init() {   
  try {

		document.getElementById('bGenOF').disabled = true;
		
		affaire_id = ParamValeur("Affaire_Id");
		client_id = ParamValeur("Client_Id");

		document.getElementById("Raison_Sociale").value = ParamValeur("Raison_Sociale");
		document.getElementById("Adresse_Fact").value = ParamValeur("Adresse_Fact");
		document.getElementById("CP_Fact").value = ParamValeur("CP_Fact");
		document.getElementById("Ville_Fact").value = ParamValeur("Ville_Fact");
		document.getElementById("Client").setAttribute("label","Client N "+ client_id);
		document.getElementById("Affaire").setAttribute("label","Affaire N "+ ParamValeur("Num_Affaire"));
		document.getElementById("Nom_Affaire").value = ParamValeur("Nom_Affaire");
		document.getElementById("Responsable").value = ParamValeur("Responsable");
		
		devis_id = ParamValeur("DevisValide");
		
		if (ParamValeur("Type_Affaire")=="C") {			
			document.getElementById('labelDevis').setAttribute("label", "Commande");
		}
		
		var corps = cookie() + "&Page=Facturation/Affaires/getRefCommande.tmpl&ContentType=xml&Devis_Id="+ devis_id;		
		var p = requeteHTTP(corps);              

  	if (p.status != "200") {
    	alert("Rception erreur " + p.status);
  	} 
		else {
			var contenu = p.responseXML.documentElement;
			
			document.getElementById('Date_Devis').value = contenu.getAttribute('date');
			document.getElementById('Numero').value = contenu.getAttribute('ref');
		}
		
		init_tree_ordres();
		init_tree_articles();
		
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_of.js#init : ' + e);
	}   
}


function genererOF() {
  try {
	
		var reference = document.getElementById('Article_Id').value;
		var designation = document.getElementById('Designation').value;
		var quantite = document.getElementById('Quantite').value;
		var com_livraison = document.getElementById('Com_Livraison').value;
		var observations = document.getElementById('Observations').value;
		var delai = document.getElementById('Delai').value;
		var ligne_id = document.getElementById('Ligne_Id').value;
		var type_ligne = document.getElementById('Type_Ligne').value;
		var qte_restante = document.getElementById('QteRestante').value;
		var ref_commande = document.getElementById('Numero').value;
		
		if (isEmpty(quantite) || !isPositiveInteger(quantite) || quantite==0) {
			showWarning("Quantit incorrecte !");
		}
		else if (quantite>qte_restante) {
			showWarning("La quantit  fabriquer ne peut tre suprieure  la quantit commande !");
		}
		else if (!isEmpty(delai) && !isDate(delai)) {
			showWarning("Date de dlai incorrecte !");
		}
		else {
			var corps = cookie() + "&Page=Facturation/Affaires/creerOF.tmpl&ContentType=xml&Devis_Id="+ devis_id;
			
			corps += "&Article_Id="+ urlEncode(reference);
			corps += "&Designation="+ urlEncode(designation);
			corps += "&Quantite="+ quantite;
			corps += "&Com_Livraison="+ urlEncode(com_livraison);
			corps += "&Observations="+ urlEncode(observations);
			corps += "&Delai="+ (isEmpty(delai)?"":prepareDateJava(delai));
			corps += "&Ligne_Id="+ ligne_id;
			corps += "&Type_Ligne="+ type_ligne;
			corps += "&Ref_Commande="+ urlEncode(ref_commande);
			
			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				document.getElementById('Article_Id').value = "";
				document.getElementById('Designation').value = "";
				document.getElementById('Quantite').value = "";
				document.getElementById('Ligne_Id').value = "";
				document.getElementById('Type_Ligne').value = "";
				document.getElementById('QteRestante').value = "";
				document.getElementById('Delai').value = "";
				document.getElementById('Com_Livraison').value = "";
				document.getElementById('Observations').value = "";
				document.getElementById('bGenOF').disabled = true;
				delete_tree_ordres();
				init_tree_ordres();
				delete_tree_articles();
				init_tree_articles();
			}
		}
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_of.js#genererOF : ' + e);
  }
}

function editerOF() {
  try {
	
		var tree = document.getElementById('ordres');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
		
			var ordre_id = tree.view.getCellText(tree.currentIndex, 'ColOrdre_Id');
		
			var page = "chrome://opensi/content/facturation/user/affaires/ordre_fabrication.xul?" + cookie() +"&Ordre_Id="+ ordre_id + "&Liste_Param="+ urlEncode(ParamValeur("Liste_Param"));
   		window.location = page;		
		}
		else {
			showWarning("Veuillez slectionner un ordre de fabrication");
		}
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_of.js#editerOF : ' + e);
  }
}

function reporterLigne() {
  try {
	
		var tree = document.getElementById('articles');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
		
			document.getElementById('Article_Id').value = tree.view.getCellText(tree.currentIndex, 'ColReference');
			document.getElementById('Designation').value = tree.view.getCellText(tree.currentIndex, 'ColDesignation');
			document.getElementById('Quantite').value = tree.view.getCellText(tree.currentIndex, 'ColQuantite');
			document.getElementById('Ligne_Id').value = tree.view.getCellText(tree.currentIndex, 'ColLigne_Id');
			document.getElementById('Type_Ligne').value = tree.view.getCellText(tree.currentIndex, 'ColType_Ligne');
			document.getElementById('QteRestante').value = tree.view.getCellText(tree.currentIndex, 'ColQuantite');
			document.getElementById('Delai').value = "";
			document.getElementById('Com_Livraison').value = "";
			document.getElementById('Observations').value = "";
			document.getElementById('bGenOF').disabled = false;
		}
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_of.js#reporterLigne : ' + e);
  }
}


function init_tree_articles() {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/articles_a_fabriquer.tmpl&ContentType=xml&Devis_Id="+ devis_id;
    load_rdf('articles', getUrlOpeneas(paramlist));
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#init_tree_articles : ' + e);
  }
}

function delete_tree_articles() {
  try {
    
    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('articles').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#delete_tree_articles : ' + e);
  }
}


function init_tree_ordres() {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/ordres_affaire.tmpl&ContentType=xml&Devis_Id="+ devis_id;
    load_rdf('ordres', getUrlOpeneas(paramlist));
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#init_tree_ordres : ' + e);
  }
}

function delete_tree_ordres() {
  try {
    
    var database = document.getElementById("ordres").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('ordres').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/fiche_affaire.js#delete_tree_ordres : ' + e);
  }
}


function retour_affaire() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?" + cookie() +"&Mode=M&Affaire_Id="+ affaire_id;
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_of.js#retour_affaire : ' + e);
  }
}

function retour_menu_principal() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?" + cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_of.js#retour_menu_principal : ' + e);
  }
}
