/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
  try {
	
    var x = (screen.width / 2) - 425;
    var y = (screen.height / 2) - 200;
    window.resizeTo(850,400);
    window.moveTo(x,y);
    document.getElementById('Numero').focus();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#init : ' + e);
  }
}


function pressOnId(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'
        
				var numero = document.getElementById('Numero').value;

				var affaire_id = existeAffaire(numero);
				
				if (affaire_id!="") {
       		ouvrirAffaire(affaire_id);
				}
				else {
					document.getElementById('Nom_Affaire').value = "";
        	document.getElementById('Client_Id').value = "";
        	document.getElementById('Article_Id').value = "";
        	document.getElementById('Raison_Sociale').value = "";
					delete_tree();
					init_tree("&Numero="+ urlEncode(document.getElementById('Numero').value));
				}				
				
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#pressOnId : ' + e);
  }
}


function pressOnIntitule(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'        
        document.getElementById('Numero').value = "";
        document.getElementById('Client_Id').value = "";
        document.getElementById('Article_Id').value = "";
        document.getElementById('Raison_Sociale').value = "";
				delete_tree();
				init_tree("&Nom_Affaire="+ urlEncode(document.getElementById('Nom_Affaire').value));
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#pressOnIntitule : ' + e);
  }
}


function pressOnClientId(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'        
        document.getElementById('Numero').value = "";
        document.getElementById('Raison_Sociale').value = "";
        document.getElementById('Article_Id').value = "";
        document.getElementById('Nom_Affaire').value = "";
				delete_tree();
				init_tree("&Client_Id="+ urlEncode(document.getElementById('Client_Id').value));
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#pressOnClientId : ' + e);
  }
}

function pressOnRaisonSociale(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'        
				document.getElementById('Numero').value = "";
        document.getElementById('Client_Id').value = "";
        document.getElementById('Article_Id').value = "";
        document.getElementById('Nom_Affaire').value = "";
				delete_tree();
				init_tree("&Raison_Sociale="+ urlEncode(document.getElementById('Raison_Sociale').value));
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#pressOnRaisonSociale : ' + e);
  }
}


function pressOnArticle(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'
        document.getElementById('Numero').value = "";
        document.getElementById('Client_Id').value = "";
        document.getElementById('Raison_Sociale').value = "";
        document.getElementById('Nom_Affaire').value = "";
				delete_tree();
        init_tree("&Article_Id="+ urlEncode(document.getElementById('Article_Id').value));
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#pressOnArticle : ' + e);
  }
}


function pressOnTree(ev) {
  try {
	
    switch(ev.keyCode) {
      case 13: // 'Enter'
        choixAffaire();
        break;
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#pressOnTree : ' + e);
  }
}


function existeAffaire(numero) {
  try {
 
		var corps = cookie() + "&Page=Facturation/Affaires/existeAffaire.tmpl&ContentType=xml&Numero="+ numero;
		var p = requeteHTTP(corps);

		if (p.status != "200") {
    	alert("Rception erreur " + p.status);
			return "";
		} 
		else {
  		var contenu = p.responseXML.documentElement;                
  		return contenu.getAttribute('Affaire_Id');  		
		}
    
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#existeAffaire : ' + e);
  }
}


function ouvrirAffaire(affaire_id) {
  try {	

		window.opener.ouvrir_affaire_win(affaire_id);
    window.close();			              
  
  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#ouvrirAffaire : ' + e);
  }  
}


function choixAffaire() {
	try {
	
		var tree = document.getElementById('affaires');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
			
			var affaire_id = tree.view.getCellText(tree.currentIndex,'ColAffaire_Id');
		
			ouvrirAffaire(affaire_id);	
		}
		
	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#choixAffaire : ' + e);
  }
}


function init_tree(param) {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/liste_affaires.tmpl&ContentType=xml"+ param;

    load_rdf('affaires', getUrlOpeneas(paramlist));
    document.getElementById('affaires').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {
    
		var database = document.getElementById("affaires").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/rech_affaire.js#delete_tree : ' + e);
  }
}
