/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {    
  try {
   
  	init_tree('commandes');
		init_tree('historique');
	 
  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#init : ' + e);
  }
}


function nouvelle_commande() {    
  try {
   
		var page = "chrome://opensi/content/facturation/user/commandes/edition_commande.xul?" + cookie();
    page += "&Mode=C";
    page += "&Etat=N";
    window.location = page;
   
  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#nouvelle_commande : ' + e);
  }
}


function rechercher_commande() {
  try {

		var url = "chrome://opensi/content/facturation/user/commandes/rech_commande.xul?" + cookie();
		window.openDialog(url,'','chrome,modal');
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#rechercher_commande : ' + e);
  }
}


function pressOncommandes(ev) {
  try {
	
		switch(ev.keyCode) {
      case 13: // 'Enter'
        ouvrir_commande();
        break;      
    }
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#pressOncommandes : ' + e);
  }
}


function pressOnHistorique(ev) {
  try {
	
		switch(ev.keyCode) {
      case 13: // 'Enter'
        ouvrir_commande_historique();
        break;      
    }
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#pressOnHistorique : ' + e);
  }
}

function idCommande(num_commande) {
  try {
 
		var corps = cookie() + "&Page=Facturation/Commandes/etatCommande.tmpl&ContentType=xml&Num_Commande="+ num_commande;
		var p = requeteHTTP(corps);

		if (p.status != "200") {
    	alert("Rception erreur " + p.status);
			return false;
		} 
		else {
  		var contenu = p.responseXML.documentElement;
  		return contenu.getAttribute('commande_id');
		}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/menu_commandes.js#etatCommande : ' + e);
  }
}

function ouvrir_commande_win(num_commande,etat,fournisseur) {
  try {

    var page = "chrome://opensi/content/facturation/user/commandes/edition_commande.xul?";
    page += cookie();
    page += "&Commande_Id=" + idCommande(num_commande);
    page += "&Etat=" + etat;
    page += "&Fournisseur_Id=" + fournisseur;
    window.location = page;
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#ouvrir_commande_win : ' + e);
  }
}


function ouvrir_commande(tree_id) {
  try {
	
		var tree = document.getElementById(tree_id);
    var v = tree.view;
		
		if (v!=null && tree.currentIndex!=-1) {
		
			var commande_id = v.getCellText(tree.currentIndex,'ColCmd_Id');
      var etat = v.getCellText(tree.currentIndex,'ColEtat');
      var fournisseur = v.getCellText(tree.currentIndex,'ColFournisseur');

			var page = "chrome://opensi/content/facturation/user/commandes/edition_commande.xul?";
      page += cookie();
      page += "&Commande_Id=" + commande_id;
      page += "&Etat=" + etat;
      page += "&Fournisseur_Id=" + fournisseur;
      window.location = page;

		}
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#ouvrir_commande : ' + e);
  }
}


function init_tree(id_tree) {
  try {
    var paramlist = "&Page=Facturation/GetRDF/commandes.tmpl&ContentType=xml";
    paramlist += "&Etat="+ id_tree;
    load_rdf(id_tree, getUrlOpeneas(paramlist));

    document.getElementById(id_tree).builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/menu_commandes.js#init_tree : ' + e);
  }
}

function delete_tree(id_tree) {
  try {
    
    var database = document.getElementById(id_tree).database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/menu_commandes.js#delete_tree : ' + e);
  }
}

function delete_tree_commandes() {
  try {
    delete_tree("commandes");		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/menu_commandes.js#delete_tree_commandes : ' + e);
  }
}



function delete_tree_historique() {
  try {
    delete_tree("historique");
  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/menu_commandes.js#delete_tree_historique : ' + e);
  }
}


function retour_menu_principal() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?" + cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;
  
	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/menu_commandes.js#retour_menu_principal : ' + e);
  }
}