/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var devis_id;
var mode_ligne;
var client_id;
var mode;
var etat_devis;
var mode_tarif;


function init() {   
  try { 
    
		setModeTarif();
		
		var paramlist = "&Page=Manager/GetRDF/taux_tva.tmpl&ContentType=xml";
    load_rdf_async('Code_TVA', getUrlOpeneas(paramlist), initTVA);

		paramlist = "&Page=Facturation/GetRDF/liste_commerciaux.tmpl&ContentType=xml";
  	load_rdf_async('Login_Resp', getUrlOpeneas(paramlist), initResp);		
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#init : ' + e);
	}   
}


function initResp() {
  try { 
		
		document.getElementById('Login_Resp').selectedIndex = 0;
		
		window.parent.addEventListener("close",demandeEnregistrement,false);
		
		mode = ParamValeur("Mode");
		
		if (mode=="C") {
			nouveauDevis();
		}
		else {
		
			// chargement

			devis_id = ParamValeur("Devis_Id");	

			init_tree();

			var corps = cookie() + "&Page=Facturation/Devis/loadArticleDevisTemp.tmpl&ContentType=xml&Devis_Id="+ devis_id;		
			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				//var contenu = p.responseXML.documentElement;
			}

			ajouterLigne("I");
			//		
		}
		
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#initResp : ' + e);
	}
}



function setModeTarif() {
	try {

    var corps = cookie() + "&Page=Manager/ParamDossier/getParamDossier.tmpl&ContentType=xml&Dossier_Id="+ get_cookie("Dossier_Id");
    var p = requeteHTTP(corps);

		if (p.status != "200") {
      alert("Rception erreur " + p.status);
    } 
  	else {			
    	var contenu = p.responseXML.documentElement;			
			mode_tarif = contenu.getAttribute('Mode_Tarif');
			
			if (mode_tarif=='Q') {
				document.getElementById('row_tarif').collapsed = true;
			}
		}
		
	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#setModeTarif : ' + e);
	} 
}


function desinit() {
	try {
	
		window.parent.removeEventListener("close",demandeEnregistrement,false);
		
	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#desinit : ' + e);
  }	
}


function initTVA() {
	try {
	
    document.getElementById('Code_TVA').value = 4;
    
	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#initTVA : ' + e);
  }
}


function disableAll() {
	try {
	
		mode = "V";
	
		document.getElementById('Commentaires').disabled = true;
		document.getElementById('Imp_Com').disabled = true;
		document.getElementById('Remise').disabled = true;
		document.getElementById('Escompte').disabled = true;
		document.getElementById('Frais_Port').disabled = true;
		document.getElementById('Date_Exp').disabled = true;
		
		document.getElementById('Login_Resp').disabled = true;
		document.getElementById('Interlocuteur').disabled = true;
		document.getElementById('bInter').disabled = true;
		
		document.getElementById('Raison_Sociale').disabled = true;
		document.getElementById('Adresse').disabled = true;
		document.getElementById('Comp_Adresse').disabled = true;
		document.getElementById('Code_Postal').disabled = true;
		document.getElementById('Ville').disabled = true;
		document.getElementById('Pays').disabled = true;
		
		document.getElementById('bCommentaire').disabled = true;
		document.getElementById('bArticle').disabled = true;
		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('bTransFac').disabled = true;
		document.getElementById('bTransAff').disabled = true;
		
		formatLigne("");
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#disableAll : ' + e);
  }
}


function ajouterLigne(type_ligne) {
  try {		

		document.getElementById('bSupprimer').disabled = true;
		mode_ligne = "C";

		document.getElementById("Type_Ligne").value = type_ligne;

		formatLigne(type_ligne);

		switch(type_ligne) {
			case "S":			
				var url = "chrome://opensi/content/facturation/user/stocks/rech_stocks.xul?"+ cookie() +"&Nouv=false&Modif_Action=false&Field_Article=Reference";
    		window.openDialog(url,'','chrome,modal');

				var reference = document.getElementById("Reference").value;

				if (!isEmpty(reference)) {

					//if (mode=="C" || !dejaPresente(reference)) {							
						
						if (mode_tarif=='Q') {
							
							var url = "chrome://opensi/content/facturation/user/devis/choix_tarif.xul?"+ cookie() +"&Article_Id="+ urlEncode(reference);
    					window.openDialog(url,'','chrome,modal');
						
							var tarif_id = document.getElementById('Tarif_Id').value;
							
							if (!isEmpty(tarif_id)) {
							
								var corps = cookie() + "&Page=Facturation/Devis/getArticleQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
								corps += "&Tarif_Id="+ tarif_id;
								
								var p = requeteHTTP(corps);              

  							if (p.status != "200") {
    							alert("Rception erreur " + p.status);
  							} 
								else {
									var contenu = p.responseXML.documentElement;

									document.getElementById("Designation").value = contenu.getAttribute("Designation");
									document.getElementById('Quantite').value = contenu.getAttribute("Quantite");
									document.getElementById("PU").value = contenu.getAttribute("Prix");
									document.getElementById('Ristourne').value = "0.00";
									document.getElementById("Code_TVA").value = contenu.getAttribute("Code_TVA");
									document.getElementById("Tarif_Id").value = "";
									document.getElementById("Libelle").value = contenu.getAttribute("Libelle");
								}								
							}
							else {
								ajouterLigne("I");
							}							
						}
						else {
							var corps = cookie() + "&Page=Facturation/Devis/getArticleTarif.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference) +"&Code_Tarif="+ document.getElementById('Code_Tarif').value;
							var p = requeteHTTP(corps);              

  						if (p.status != "200") {
    						alert("Rception erreur " + p.status);
  						} 
							else {
								var contenu = p.responseXML.documentElement;

								document.getElementById("Designation").value = contenu.getAttribute("Designation");
								document.getElementById('Quantite').value = 1;
								document.getElementById("PU").value = contenu.getAttribute("Prix");
								document.getElementById('Ristourne').value = "0.00";
								document.getElementById("Code_TVA").value = contenu.getAttribute("Code_TVA");
								document.getElementById("Libelle").value = "";
							}
						}
					/*}
					else {
						showWarning("Cet article est dj prsent dans le devis !");
						ajouterLigne("I");
					}	*/			
				}
				else {
					ajouterLigne("I");
				}

				break;

			case "I": 

				document.getElementById('Reference').value = "";
				document.getElementById('Designation').value = "";
				document.getElementById('Quantite').value = 1;
				document.getElementById('PU').value = "";
				document.getElementById('Ristourne').value = "0.00";
				document.getElementById('Code_TVA').value = 4;
				document.getElementById("Libelle").value = "";
				break;	
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#ajouterLigne : ' + e);
	}
}


function formatLigne(type_ligne) {
  try {
	
		switch(type_ligne) {
			case "S":
				document.getElementById('Reference').disabled = true;
				document.getElementById('Designation').disabled = true;
				document.getElementById('Quantite').disabled = false;
				document.getElementById('PU').disabled = false;
				document.getElementById('Ristourne').disabled = false;
				document.getElementById('Code_TVA').disabled = false;
				document.getElementById('bValider').disabled = false;
				document.getElementById('bAnnuler').disabled = false;
				break;
				
			case "I":
				document.getElementById('Reference').disabled = false;
				document.getElementById('Designation').disabled = false;
				document.getElementById('Quantite').disabled = false;
				document.getElementById('PU').disabled = false;
				document.getElementById('Ristourne').disabled = false;
				document.getElementById('Code_TVA').disabled = false;
				document.getElementById('bValider').disabled = false;
				document.getElementById('bAnnuler').disabled = false;
				break;
			
			default:
				document.getElementById('Reference').value = "";
				document.getElementById('Designation').value = "";
				document.getElementById('Quantite').value = "";
				document.getElementById('PU').value = "";
				document.getElementById('Ristourne').value = "";
				document.getElementById('Libelle').value = "";
				document.getElementById('Code_TVA').value = 4;
				document.getElementById('Reference').disabled = true;
				document.getElementById('Designation').disabled = true;
				document.getElementById('Quantite').disabled = true;
				document.getElementById('PU').disabled = true;
				document.getElementById('Ristourne').disabled = true;
				document.getElementById('Code_TVA').disabled = true;				
				document.getElementById('bSupprimer').disabled = true;
				document.getElementById('bValider').disabled = true;
				document.getElementById('bAnnuler').disabled = true;				
				break;
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#formatLigne : ' + e);
	}
}


function dejaPresente(reference) {
  try {

		var corps = cookie() + "&Page=Facturation/Devis/existeArticleDevis.tmpl&ContentType=xml&Reference="+ urlEncode(reference) +"&Devis_Id="+ devis_id;		
		var p = requeteHTTP(corps);              

  	if (p.status != "200") {
    	alert("Rception erreur " + p.status);
			return false;
  	} 
		else {
			var contenu = p.responseXML.documentElement;

			return contenu.getAttribute("existe")=="true";
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#dejaPresente : ' + e);
	}
}


function pressOnWindow(ev) {
	try {
	
		if (ev.altKey && mode!="V") {
			switch(ev.charCode) {
      	case 97: // 'a'
        	ajouterLigne("S");
        	break;
				case 116: // 't'
					modifierTarif();
					break;
    	}
		}
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#pressOnWindow : ' + e);
  }
}


function modifierTarif() {
	try {
	
		if (mode_ligne = "M" && document.getElementById('Type_Ligne').value=='S') {
		
			if (mode_tarif=='Q') {
				
				var reference = document.getElementById('Reference').value;
				
				var url = "chrome://opensi/content/facturation/user/devis/choix_tarif.xul?"+ cookie() +"&Article_Id="+ urlEncode(reference);
    		window.openDialog(url,'','chrome,modal');

				var tarif_id = document.getElementById('Tarif_Id').value;

				if (!isEmpty(tarif_id)) {

					var corps = cookie() + "&Page=Facturation/Devis/getArticleQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
					corps += "&Tarif_Id="+ tarif_id;

					var p = requeteHTTP(corps);              

  				if (p.status != "200") {
    				alert("Rception erreur " + p.status);
  				} 
					else {
						var contenu = p.responseXML.documentElement;

						//document.getElementById("Designation").value = contenu.getAttribute("Designation");
						document.getElementById('Quantite').value = contenu.getAttribute("Quantite");
						document.getElementById("PU").value = contenu.getAttribute("Prix");
						//document.getElementById('Ristourne').value = "0.00";
						//document.getElementById("Code_TVA").value = contenu.getAttribute("Code_TVA");
						document.getElementById("Tarif_Id").value = "";
						document.getElementById("Libelle").value = contenu.getAttribute("Libelle");
					}								
				}						
			}		
		}
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#modifierTarif : ' + e);
  }
}


function ouvrirLigne() {
  try {

		var tree = document.getElementById("articles");
		
		if (tree.view!=null && tree.currentIndex!=-1 && mode=="M") {
		
			if (tree.view.getCellText(tree.currentIndex,'ColType_Ligne')=="C") {
				ajouterLigne("I");
			}
			else {
				mode_ligne = "M";
				document.getElementById('bSupprimer').disabled = false;

				document.getElementById("Reference").value = tree.view.getCellText(tree.currentIndex,'ColReference');
				document.getElementById("Designation").value = tree.view.getCellText(tree.currentIndex,'ColDesignation');
				document.getElementById("Quantite").value = tree.view.getCellText(tree.currentIndex,'ColQuantite');
				document.getElementById("PU").value = tree.view.getCellText(tree.currentIndex,'ColPU');
				document.getElementById("Code_TVA").value = tree.view.getCellText(tree.currentIndex,'ColCode_TVA');
				document.getElementById("Ristourne").value = tree.view.getCellText(tree.currentIndex,'ColRistourne');			
				document.getElementById("Type_Ligne").value = tree.view.getCellText(tree.currentIndex,'ColType_Ligne');
				document.getElementById("Rank").value = tree.view.getCellText(tree.currentIndex,'ColRank');
				document.getElementById("Libelle").value = tree.view.getCellText(tree.currentIndex,'ColLibelle');

				formatLigne(document.getElementById("Type_Ligne").value);
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#ouvrirLigne : ' + e);
	}
}

function ouvrirCommentaire() {
  try {

		var tree = document.getElementById("articles");
		
		if (tree.view!=null && tree.currentIndex!=-1 && mode=="M") {
		
			if (tree.view.getCellText(tree.currentIndex,'ColType_Ligne')=="C") {
				editerCommentaire();
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#ouvrirCommentaire : ' + e);
	}
}


function validerLigne() {
  try {
		
		if (mode=="C") {
			enregistrerDevis();
		}
		
		if (mode_ligne=="C") {
			var corps = cookie() + "&Page=Facturation/Devis/ajouterArticle.tmpl&ContentType=xml";
		}
		else {
			var corps = cookie() + "&Page=Facturation/Devis/modifierArticle.tmpl&ContentType=xml";			
		}

		var type_ligne = document.getElementById("Type_Ligne").value;

		var reference = document.getElementById("Reference").value;
		var designation = document.getElementById("Designation").value;
		var quantite = document.getElementById("Quantite").value;
		var pu = document.getElementById("PU").value;
		var ristourne = document.getElementById("Ristourne").value;
		var code_tva = document.getElementById("Code_TVA").value;		
		var rank = document.getElementById("Rank").value;
		var libelle = document.getElementById("Libelle").value;

		corps += "&Reference="+ urlEncode(reference) +"&Designation="+ urlEncode(designation) +"&Quantite="+ quantite +"&Type_Ligne="+ type_ligne;
		corps += "&Prix="+ pu +"&Ristourne="+ ristourne +"&Code_TVA="+ code_tva +"&Devis_Id="+ devis_id +"&Rank="+ rank +"&Libelle="+ urlEncode(libelle);
		
		if (isEmpty(designation)) { showWarning("Dsignation de l'article manquante !");	}
		//else if (type_ligne=="I" && isEmpty(reference)) { showWarning("Rfrence de l'article manquante !");	}
		else if (isEmpty(quantite) || !isPositive(quantite) || !checkDecimal(quantite,2)) { showWarning("Quantit incorrecte !");	}
		else if (isEmpty(pu) || !isPositiveOrNull(pu) || !checkDecimal(pu,4)) { showWarning("Prix unitaire incorrect !");	}
		else if (isEmpty(ristourne) || !isTaux(ristourne)) { showWarning("Taux de ristourne incorrect !");	}
		else {		
			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				//var contenu = p.responseXML.documentElement;
				ajouterLigne("I");
				delete_tree();
				init_tree_temp();
				setModifie(true);
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#validerLigne : ' + e);
	}
}


function annulerLigne() {
  try {
	
		ajouterLigne("I");
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#annulerLigne : ' + e);
	}
}

function supprimerLigne() {
  try {
	
		var rank = document.getElementById("Rank").value;
	
		var corps = cookie() + "&Page=Facturation/Devis/supprimerArticle.tmpl&ContentType=xml&Devis_Id="+ devis_id +"&Rank="+ rank;		
		var p = requeteHTTP(corps);  

  	if (p.status != "200") {
    	alert("Rception erreur " + p.status);
  	} 
		else {
			//var contenu = p.responseXML.documentElement;
			ajouterLigne("I");
			delete_tree();
			init_tree_temp();
			setModifie(true);
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#supprimerLigne : ' + e);
	}
}


function supprimerDevis() {
  try {
	
		if (window.confirm("Confirmez-vous la suppression du devis ?")) {
	
			var corps = cookie() + "&Page=Facturation/Devis/supprimerDevis.tmpl&ContentType=xml&Devis_Id="+ devis_id;		
			var p = requeteHTTP(corps);  

  		if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				showMessage("Le devis a t supprim !");
				retour_devis();
			}
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#supprimerDevis : ' + e);
	}
}


function transAffaire() {
  try {
	
		var tree = document.getElementById("articles");
	
		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		}
		else {	
			if (window.confirm("Etes-vous sr de vouloir passer le devis en affaire ?")) {
				var corps = cookie() + "&Page=Facturation/Devis/transDevisAffaire.tmpl&ContentType=xml&Devis_Id="+ devis_id;		
				var p = requeteHTTP(corps);  

  			if (p.status != "200") {
    			alert("Rception erreur " + p.status);
  			}
				else {
					var contenu = p.responseXML.documentElement;
					var affaire_id = contenu.getAttribute("Affaire_Id");
				
					var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?"+ cookie() +"&Affaire_Id="+ affaire_id;
    			window.location = page;
				}
			}
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#transAffaire : ' + e);
	}
}


function transFacture() {
  try {
	
		var tree = document.getElementById("articles");
	
		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		}
		else {	
			if (window.confirm("Etes-vous sr de vouloir passer le devis en facture ?")) {
				var corps = cookie() + "&Page=Facturation/Devis/transDevisFacture.tmpl&ContentType=xml&Devis_Id="+ devis_id;		
				var p = requeteHTTP(corps);  

  			if (p.status != "200") {
    			alert("Rception erreur " + p.status);
  			}
				else {
					var contenu = p.responseXML.documentElement;
					var facture_id = contenu.getAttribute("Facture_Id");
				
					var page = "chrome://opensi/content/facturation/user/factu_directe/edition_facture.xul?"+ cookie() +"&Facture_Id="+ facture_id;
    			window.location = page;
				}
			}
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#transFacture : ' + e);
	}
}


function enregistrerDevis() {
  try {
	
		var remise = document.getElementById('Remise').value;
		var frais_port = document.getElementById('Frais_Port').value;
		var escompte = document.getElementById('Escompte').value;
		var date_exp = document.getElementById('Date_Exp').value;
		var raison_sociale = document.getElementById('Raison_Sociale').value;
		var adresse = document.getElementById('Adresse').value;
		var comp_adresse = document.getElementById('Comp_Adresse').value;
		var code_postal = document.getElementById('Code_Postal').value;
		var ville = document.getElementById('Ville').value;
		var pays = document.getElementById('Pays').value;
		var login_resp = document.getElementById('Login_Resp').value;
		var client_id = document.getElementById('Client_Id').value;
		var num_inter = document.getElementById('Interlocuteur').value;
	
		if (isEmpty(remise) || !isTaux(remise)) { showWarning("Taux de remise incorrect !"); }
		else if (isEmpty(raison_sociale)) { showWarning("Veuillez indiquer la raison sociale du client !"); }
		else if (isEmpty(frais_port) || !isPositiveOrNull(frais_port)) { showWarning("Frais de port incorrects !"); }
		else if (isEmpty(escompte) || !isTaux(escompte)) { showWarning("Taux d'escompte incorrect !"); }
		else if (!isEmpty(date_exp) && !isDate(date_exp)) { showWarning("Date d'expiration de l'offre incorrecte !"); }
		else {
		
			var corps;
			
			if (mode=="C") {		
				corps = cookie() + "&Page=Facturation/Devis/creerDevis.tmpl&ContentType=xml";
			}
			else {
				corps = cookie() + "&Page=Facturation/Devis/modifierDevis.tmpl&ContentType=xml&Devis_Id="+ devis_id;
			}			
			
			corps += "&Remise="+ remise +"&Frais_Port="+ frais_port +"&Escompte="+ escompte;
			corps += "&Commentaires="+ urlEncode(document.getElementById('Commentaires').value);
			corps += "&Imp_Com="+ (document.getElementById('Imp_Com').checked?"1":"0");
			corps += "&Date_Exp="+ (!isEmpty(date_exp)?prepareDateJava(date_exp):"");
			corps += "&Total_HT="+ document.getElementById('TotalHT').value;
			corps += "&Code_Tarif="+ document.getElementById('Code_Tarif').value;
			
			corps += "&Raison_Sociale="+ urlEncode(raison_sociale);
			corps += "&Adresse="+ urlEncode(adresse);
			corps += "&Comp_Adresse="+ urlEncode(comp_adresse);
			corps += "&Code_Postal="+ urlEncode(code_postal);
			corps += "&Ville="+ urlEncode(ville);
			corps += "&Pays="+ urlEncode(pays);
			corps += "&Login_Resp="+ urlEncode(login_resp);
			corps += "&Client_Id="+ urlEncode(client_id);
			corps += "&Num_Inter="+ num_inter; 
					
			var p = requeteHTTP(corps);              

  		if (p.status != "200") {
    		alert("Rception erreur " + p.status);
  		} 
			else {
				if (mode=="C") {
					var contenu = p.responseXML.documentElement;
					devis_id = contenu.getAttribute("Devis_Id");
					chargerDevis();
				}
			}
		
			if (mode=="M") {
				corps = cookie() + "&Page=Facturation/Devis/saveArticleDevisTemp.tmpl&ContentType=xml&Devis_Id="+ devis_id;		
				p = requeteHTTP(corps);              

  			if (p.status != "200") {
    			alert("Rception erreur " + p.status);
  			} 
				else {
					//var contenu = p.responseXML.documentElement;
				}
			}
			setModifie(false);
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#enregistrerDevis : ' + e);
	}
}


function calculTotaux() {
  try {
	
		var taux_remise = parseFloat(document.getElementById('Remise').value);
		var taux_escompte = parseFloat(document.getElementById('Escompte').value);
		var frais_port = parseFloat(document.getElementById('Frais_Port').value);
		
		if (isTaux(taux_remise) && isTaux(taux_escompte) && isPositiveOrNull(frais_port)) {
		
			var tree = document.getElementById("articles");
			
			var montant_tva = 0;
			var montant_ht = 0;
			var tva_port = getTva(4);
		
			if (tree.view!=null) {

				for (var i=0;i<tree.view.rowCount;i++) {

					if (tree.view.getCellText(i,'ColType_Ligne')!="C") {

						montant_ht += parseFloat(tree.view.getCellText(i,'ColTotal'));
						montant_tva += parseFloat(tree.view.getCellText(i,'ColTotal')) * getTva(tree.view.getCellText(i,'ColCode_TVA'))/100;

					}			
				}			
			}

			var montant_remise = montant_ht * parseFloat(taux_remise/100);

			var total_ht = montant_ht * (1 - parseFloat(taux_remise/100)) + frais_port;

			montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100);

			var montant_ttc = total_ht + montant_tva;

			var montant_escompte = montant_ttc * parseFloat(taux_escompte/100);

			var total_ttc = montant_ttc - montant_escompte;

			document.getElementById('MontantHT').value = formatNombre(montant_ht,"0.00");
			document.getElementById('MontantRemise').value = formatNombre(montant_remise,"0.00");
			document.getElementById('MontantFrais_Port').value = formatNombre(frais_port,"0.00");		
			document.getElementById('TotalHT').value = formatNombre(total_ht,"0.00");
			document.getElementById('TVA').value = formatNombre(montant_tva,"0.00");
			document.getElementById('MontantTTC').value = formatNombre(montant_ttc,"0.00");
			document.getElementById('MontantEscompte').value = formatNombre(montant_escompte,"0.00");
			document.getElementById('TotalTTC').value = formatNombre(total_ttc,"0.00");
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#calculTotaux : ' + e);
	}
}


function demandeEnregistrement() {
  try {
	
		if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes au devis ?")) {
				enregistrerDevis();
			}
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#demandeEnregistrement : ' + e);
	}
}


function setModifie(m) {
  try {
	
		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelDevis').setAttribute("label","Devis (modifi)");
			document.getElementById('bVisualiser').disabled = true;
			document.getElementById('bTransAff').disabled = true;
			document.getElementById('bTransFac').disabled = true;
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelDevis').setAttribute("label","Devis");
			document.getElementById('bVisualiser').disabled = false;
			document.getElementById('bTransAff').disabled = (etat_devis!='N');
			document.getElementById('bTransFac').disabled = (etat_devis!='N');
		}
	
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#setModifie : ' + e);
	}
}


function init_tree() {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/articles_devis.tmpl&ContentType=xml&Devis_Id="+ devis_id;
    load_rdf_async('articles', getUrlOpeneas(paramlist),chargerDevis);
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#init_tree : ' + e);
  }
}

function delete_tree() {
  try {
    
    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('articles').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#delete_tree : ' + e);
  }
}


function nouveauDevis() {
  try {
	
		mode = "C";
		
		document.getElementById('Raison_Sociale').disabled = false;
		document.getElementById('Adresse').disabled = false;
		document.getElementById('Comp_Adresse').disabled = false;
		document.getElementById('Code_Postal').disabled = false;
		document.getElementById('Ville').disabled = false;
		document.getElementById('Pays').disabled = false;
		document.getElementById('Code_Tarif').disabled = false;
		document.getElementById('Login_Resp').disabled = false;
		document.getElementById('Interlocuteur').disabled = false;
		document.getElementById('bInter').disabled = false;
		
		document.getElementById('Commentaires').value = "";
		document.getElementById('Date_Devis').value = "";
		document.getElementById('Numero').value = "";
		document.getElementById('Imp_Com').checked = false;
		document.getElementById('Remise').value = "0.00";
		document.getElementById('Escompte').value = "0.00";
		document.getElementById('Frais_Port').value = "0.00";
		document.getElementById('Date_Exp').value = "";
		
		document.getElementById('Raison_Sociale').value = "";
		document.getElementById('Adresse').value = "";
		document.getElementById('Comp_Adresse').value = "";
		document.getElementById('Code_Postal').value = "";
		document.getElementById('Ville').value = "";
		document.getElementById('Pays').value = "";
		document.getElementById('Client_Id').value = "";
		
		document.getElementById('MontantHT').value = "0.00";
		document.getElementById('MontantRemise').value = "0.00";
		document.getElementById('MontantFrais_Port').value = "0.00";		
		document.getElementById('TotalHT').value = "0.00";
		document.getElementById('TVA').value = "0.00";
		document.getElementById('MontantTTC').value = "0.00";
		document.getElementById('MontantEscompte').value = "0.00";
		document.getElementById('TotalTTC').value = "0.00";
		
		document.getElementById('Code_Tarif').value = 1;
		document.getElementById('Interlocuteur').value = 0;
	
		document.getElementById('Creation').label = "";
		document.getElementById('Modification').label = "";
		document.getElementById('Creation').collapsed = true;
		document.getElementById('Modification').collapsed = true;
		document.getElementById('Fiche').label = "";
		
		document.getElementById('labelClient').setAttribute("label", "Client");
		
		ajouterLigne("I");
		
		delete_tree();
		delete_contacts();
		
		setModifie(false);
		document.getElementById('bVisualiser').disabled = true;
		document.getElementById('row_interlocuteur').collapsed = true;
		document.getElementById('chercher_client').collapsed = false;
		document.getElementById('bTransAff').collapsed = true;
		document.getElementById('bTransFac').collapsed = true;
		
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/edition_livraison.js#nouveau_bon : ' + e);
  }
}


function chargerDevis() {
  try {
	
		mode = "M";
		document.getElementById('chercher_client').collapsed = true;
		document.getElementById('Code_Tarif').disabled = true;
		document.getElementById('bTransFac').collapsed = false;
	
		var corps = cookie() + "&Page=Facturation/Devis/getDevis.tmpl&ContentType=xml&Devis_Id="+ devis_id;

		var p = requeteHTTP(corps);              

  	if (p.status != "200") {
    	alert("Rception erreur " + p.status);
  	} 
		else {
			var contenu = p.responseXML.documentElement;
			
			var numero = contenu.getAttribute('Num_Entier');

			document.getElementById('Remise').value = contenu.getAttribute('Remise');
			document.getElementById('Escompte').value = contenu.getAttribute('Escompte');
			document.getElementById('Frais_Port').value = contenu.getAttribute('Frais_Port');
			document.getElementById('Commentaires').value = contenu.getAttribute('Commentaires');
			document.getElementById('Imp_Com').checked = contenu.getAttribute('Imp_Com')=="1";
			document.getElementById('Date_Devis').value = contenu.getAttribute('Date_Devis');
			document.getElementById('Numero').value = numero;
			document.getElementById('Date_Exp').value = contenu.getAttribute('Date_Exp');
			
			document.getElementById('Raison_Sociale').value = contenu.getAttribute('Raison_Sociale');
			document.getElementById('Adresse').value = contenu.getAttribute('Adresse');
			document.getElementById('Comp_Adresse').value = contenu.getAttribute('Comp_Adresse');
			document.getElementById('Code_Postal').value = contenu.getAttribute('Code_Postal');
			document.getElementById('Ville').value = contenu.getAttribute('Ville');
			document.getElementById('Pays').value = contenu.getAttribute('Pays');
			document.getElementById('Code_Tarif').value = contenu.getAttribute('Code_Tarif');
			var client_id = contenu.getAttribute('Client_Id');
			document.getElementById('Client_Id').value = client_id;
			if (client_id!="") {		
				document.getElementById('labelClient').setAttribute("label", "Client N "+ client_id);
				document.getElementById('row_interlocuteur').collapsed = false;
				document.getElementById('Raison_Sociale').disabled = true;
				document.getElementById('Adresse').disabled = true;
				document.getElementById('Comp_Adresse').disabled = true;
				document.getElementById('Code_Postal').disabled = true;
				document.getElementById('Ville').disabled = true;
				document.getElementById('Pays').disabled = true;
				document.getElementById('bTransAff').collapsed = false;
			}
			else {
				document.getElementById('labelClient').setAttribute("label", "Client");
				document.getElementById('row_interlocuteur').collapsed = true;
				document.getElementById('Raison_Sociale').disabled = false;
				document.getElementById('Adresse').disabled = false;
				document.getElementById('Comp_Adresse').disabled = false;
				document.getElementById('Code_Postal').disabled = false;
				document.getElementById('Ville').disabled = false;
				document.getElementById('Pays').disabled = false;
				document.getElementById('bTransAff').collapsed = true;
			}
			
			document.getElementById('Login_Resp').value = contenu.getAttribute('Login_Resp');
			charger_contacts(contenu.getAttribute("Num_Inter"));
			
			document.getElementById('Creation').label = "Devis cr le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
			document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
			document.getElementById('Fiche').label = "Devis N "+ numero;
			document.getElementById('Creation').collapsed = false;
			document.getElementById('Modification').collapsed = false;
			
			setModifie(false);
			
			etat_devis = contenu.getAttribute("Etat");
			
			if (etat_devis=='A' || etat_devis=='F') {
				disableAll();
			}
			
			calculTotaux();
		}
			
	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#chargerDevis : ' + e);
  }
}

function init_tree_temp() {
  try {
    
    var paramlist = "&Page=Facturation/GetRDF/articles_devis.tmpl&ContentType=xml&Devis_Id="+ devis_id +"&Temp=true";
    load_rdf_async('articles', getUrlOpeneas(paramlist), calculTotaux);
    
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#init_tree_temp : ' + e);
  }
}


function visualiserDevis() {
  try {
	
		var tree = document.getElementById("articles");
	
		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le devis ne contient aucune ligne !");
		}
		else {
			var page = "chrome://opensi/content/facturation/user/devis/devis.xul?" + cookie() +"&Devis_Id="+ devis_id;
	  	window.location = page;
		}
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#visualiserDevis : ' + e);
  }
}


function editerCommentaire() {
  try {

		var tree = document.getElementById("articles");
	
		if (tree.view!=null && tree.currentIndex!=-1) {
			
			var rank = tree.view.getCellText(tree.currentIndex,'ColRank');
			
			var url = "chrome://opensi/content/facturation/user/devis/commentaire.xul?"+ cookie() +"&Devis_Id="+ devis_id +"&Rank="+ rank;
    	window.openDialog(url,'','chrome,modal');
			
			delete_tree();
			init_tree_temp();
			ajouterLigne("I");
			setModifie(true);
		}
		else {
			showWarning("Aucun article ou commentaire slectionn !");
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#editerCommentaire : ' + e);
  }
}


function charger_coordfact() {
  try {

		var client_id = document.getElementById("Client_Id").value;

		var corps = cookie() + "&Page=Facturation/Devis/getCoordFact.tmpl&ContentType=xml&Client_Id="+ urlEncode(client_id);
		
		var p = requeteHTTP(corps);              

  	if (p.status != "200") {
    	alert("Rception erreur " + p.status);
  	} 
		else {
			var contenu = p.responseXML.documentElement;
			
			document.getElementById("Raison_Sociale").value = contenu.getAttribute("Raison_Sociale");
			document.getElementById("Adresse").value = contenu.getAttribute("Adresse_Fact");
			document.getElementById("Code_Postal").value = contenu.getAttribute("CP_Fact");
			document.getElementById("Comp_Adresse").value = contenu.getAttribute("Comp_Adresse_Fact");
			document.getElementById("Ville").value = contenu.getAttribute("Ville_Fact");
			document.getElementById("Pays").value = contenu.getAttribute("Pays_Fact");
			document.getElementById("Login_Resp").value = contenu.getAttribute("Login_Resp");
			document.getElementById('Remise').value = contenu.getAttribute("Remise");
			document.getElementById('Code_Tarif').value = contenu.getAttribute("Code_Tarif");
			
			document.getElementById('labelClient').setAttribute("label", "Client N "+ client_id);
			document.getElementById('row_interlocuteur').collapsed = false;
			document.getElementById('Adresse').disabled = true;
			document.getElementById('Comp_Adresse').disabled = true;
			document.getElementById('Code_Postal').disabled = true;
			document.getElementById('Ville').disabled = true;
			document.getElementById('Pays').disabled = true;
			document.getElementById('Raison_Sociale').disabled = true;
			document.getElementById('Code_Tarif').disabled = true;
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#charger_coordfact : ' + e);
  }
}


var valContact;

function charger_contacts(val) {
  try {
		
		delete_contacts();
		
		valContact = val;
		
		var client_id = document.getElementById("Client_Id").value;
		
		var paramlist = "&Page=Facturation/GetRDF/contacts_client.tmpl&ContentType=xml&Client_Id="+ urlEncode(client_id);
    load_rdf_async('Interlocuteur', getUrlOpeneas(paramlist), initContacts);
		
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/edition_devis.js#charger_contacts : ' + e);
  }
}


function delete_contacts() {
  try {
	
    var database = document.getElementById("Interlocuteur").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('Interlocuteur').builder.rebuild();
		document.getElementById('Interlocuteur').selectedIndex = 0;
		
  } catch (e) {
    recup_erreur('erreur dans erreur dans facturation/user/devis/edition_devis.js#delete_contacts: ' + e);
  }
}


function initContacts() {
  try {

		var modifie = document.getElementById("Modifie").value;

		if (mode=="C") {
			document.getElementById('Interlocuteur').selectedIndex = 0;
		}
		else {
			document.getElementById('Interlocuteur').value = valContact;
		}
		
		if (modifie!="y") { setModifie(false); }

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/edition_devis.js#initContacts : ' + e);
  }
}


function rechercherClient() {
  try {
	
		var url = "chrome://opensi/content/facturation/user/clients/rech_client.xul?"+ cookie() +"&Nouv=false&Modif_Action=false&Field_Client=Client_Id&Bloque=true";
    window.openDialog(url,'','chrome,modal');
		
		var client_id = document.getElementById("Client_Id").value;
		
		if (client_id != "") {
			setModifie(true);
			charger_coordfact();
			charger_contacts(0);
		}
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/edition_devis.js#rechercherClient : ' + e);
  }
}


function newInterlocuteur() {
	try {

		var url = "chrome://opensi/content/facturation/user/affaires/ajouter_interlocuteur.xul?" + cookie() +"&Client_Id="+ urlEncode(document.getElementById("Client_Id").value);
		window.openDialog(url,'','chrome,modal');

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/devis/edition_devis.js#newInterlocuteur : ' + e);
  }
}


function retour_devis() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/devis/menu_devis.xul?" + cookie();
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#retour_devis : ' + e);
  }
}

function retour_menu_principal() {
  try {
	
    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?" + cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#retour_menu_principal : ' + e);
  }
}
