/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


mode = "C";

function init() {
  try {

    var x = (screen.width / 2) - 250;
    var y = (screen.height / 2) - 150;
    window.resizeTo(500,300);
    window.moveTo(x,y);
    document.getElementById('Ref_Fournisseur').focus();
		
		mode = ParamValeur("Mode");
		
		if (mode=="C") {
			nouveauDetails();
		}
		else {
			chargerDetails();
		}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/details_fournisseur.js#init : ' + e);
  }
}


function nouveauDetails() {
	try {
	
		document.getElementById('Ref_Fournisseur').value = "";
		document.getElementById('Prix_Achat').value = "";
		document.getElementById('Frais_Appro').value = 0;
		document.getElementById('Prix_Revient').value = 0;
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/details_fournisseur.js#nouveauDetails : ' + e);
  }
}


function calculerPrixRevient() {
	try {

		var prix_achat = parseFloat(document.getElementById('Prix_Achat').value);
		var frais_appro = parseFloat(document.getElementById('Frais_Appro').value);
		
		if (isNaN(prix_achat)) { prix_achat = 0; }
		if (isNaN(frais_appro)) { frais_appro = 0; }
		
		document.getElementById('Prix_Revient').value = formatNombre((prix_achat + frais_appro),"0.00#");
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/details_fournisseur.js#calculerPrixRevient : ' + e);
  }
}


function chargerDetails() {
  try {
	
		var fournisseur_id = ParamValeur("Fournisseur_Id");
		var article_id = ParamValeur("Article_Id");
	
		var corps = cookie() + "&Page=Facturation/Stocks/getDetailsFournisseur.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id) +"&Fournisseur_Id="+urlEncode(fournisseur_id);
    var p = requeteHTTP(corps);

    if (p.status != "200") {
      alert("Rception erreur " + p.status);
    } 
		else {
      var contenu = p.responseXML.documentElement;

			document.getElementById('Ref_Fournisseur').value = contenu.getAttribute('Ref_Fournisseur');
      document.getElementById('Prix_Achat').value = contenu.getAttribute('Prix_Achat');
      document.getElementById('Frais_Appro').value = contenu.getAttribute('Frais_Appro');
      document.getElementById('Date_Modif').value = contenu.getAttribute('Date_Modif');
      document.getElementById('Date_Mise_Appli').value = contenu.getAttribute('Date_Mise_Appli');     
      //document.getElementById('Quantite_Entree').value = contenu.getAttribute('Quantite_Entree');
			
			document.getElementById('Date_Modif').collapsed = false;
      document.getElementById('Date_Mise_Appli').collapsed = false;
			calculerPrixRevient();
    }
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/details_fournisseur.js#chargerDetails : ' + e);
  }
}


function ajouterDetails() {
  try {

		var fournisseur_id = ParamValeur("Fournisseur_Id");
		var article_id = ParamValeur("Article_Id");
		
		var ref_fournisseur = document.getElementById('Ref_Fournisseur').value;
		var prix_achat = document.getElementById('Prix_Achat').value;
		var frais_appro = document.getElementById('Frais_Appro').value;

		if (mode=="C") {
			var corps = cookie() + "&Page=Facturation/Stocks/ajouterFournisseurArticle.tmpl&ContentType=xml&Article_Id="+urlEncode(article_id)+"&Fournisseur_Id="+ urlEncode(fournisseur_id);
		}
		else {
			var corps = cookie() + "&Page=Facturation/Stocks/modifierFournisseurArticle.tmpl&ContentType=xml&Article_Id="+urlEncode(article_id)+"&Fournisseur_Id="+ urlEncode(fournisseur_id);
		}
		
		corps += "&Frais_Appro="+ frais_appro +"&Ref_Fournisseur="+ urlEncode(ref_fournisseur) +"&Prix_Achat="+ prix_achat;
		
		if (isEmpty(prix_achat)) { showWarning("Veuillez spcifier un prix d'achat !"); }
		else if (isEmpty(frais_appro)) { showWarning("Veuillez spcifier les frais d'approvisionnement !"); }
		else if (isEmpty(ref_fournisseur)) { showWarning("Veuillez spcifier la rfrence de l'article chez ce fournisseur !"); }
		
		else if (!isPositiveOrNull(prix_achat)) { showWarning("Prix d'achat incorrect !"); }
		else if (!isPositiveOrNull(frais_appro)) { showWarning("Frais d'approvisionnement incorrects !"); }
		else {
			var p = requeteHTTP(corps);

			if (p.status != "200") {
  			alert("Rception erreur " + p.status);
			} 
			else {
				window.close();
			}
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/details_fournisseur.js#ajouterDetails : ' + e);
  }
}
