/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Bibliothque de fonctions utiles  opensi ("en vrac").
 */

function get_num_version() {
  return 2;
}

function get_release() {
  return 0;
}

function get_sous_release() {
  return 7;
}

var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

try {
  // Extraction des paramtres de la requte HTTP
  // et initialise la variable "paramOk"  false
  // s'il n'y a aucun paramtre.
  if (!location.search) {
    paramOk = false;
  }
  else {
    // liminer le "?"
    nReq = location.search.substring(1,location.search.length)
    // Extrait les diffrents paramtres avec leur valeur.
    nReq = nReq.split("&");
    param = new FaitTableau(nReq.length-1)
    for (var i=0;i<(nReq.length);i++) {
      param[i] = nReq[i]
    }
  }      
} catch (e) {
  recup_erreur('erreur dans libs/util.js# : ' + e);
}

function get_version() {
  try {
    var retour = '' + get_num_version() + '.' + get_release() + '.' + get_sous_release();
    return retour;
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_version : ' + e);
  }
}

function get_os() {
  try {
    return navigator.platform;
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_os : ' + e);
  }
}

function get_pref_module() {
  try {
    if (prefs.getPrefType("opensi.serveur.module") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.serveur.module")
    } else {
      return "Compta";
    }
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_module : ' + e);
  }
}

function get_pref_ssl() {
  try {
    if (prefs.getPrefType("opensi.serveur.ssl") == prefs.PREF_BOOL){
      return prefs.getBoolPref("opensi.serveur.ssl")
    } else {
      return false;
    }
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_ssl : ' + e);
  }
}

function get_pref_protocol() {
  try {
    if (get_pref_ssl()){
      return "https";
    } else {
      return "http";
    }
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_protocol : ' + e);
  }
}

function get_pref_ipserveur() {
  try {
    if (prefs.getPrefType("opensi.serveur.addresse") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.serveur.addresse");
    } else {
      return "localhost";
    }
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_ipserveur : ' + e);
  }
}

function get_pref_porttomcat() {
  try {
    if (prefs.getPrefType("opensi.serveur.port") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.serveur.port");
    } else {
      return "8080";
    }
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_porttomcat : ' + e);
  }
}

function get_pref_servlet() {
  try {
    if (prefs.getPrefType("opensi.serveur.servlet") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.serveur.servlet");
    } else {
      return "OpenSI";
    }
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_servlet : ' + e);
  }
}

function get_pref_mailcomptable() {
  try {
    if (prefs.getPrefType("opensi.mailcomptable") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.mailcomptable");
    } else {
      return "";
    }
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_mailcomptable : ' + e);
  }
}

function get_pref_logmail() {
  try {
    if (prefs.getPrefType("network.protocol-handler.app.mailto") == prefs.PREF_STRING){
      return prefs.getCharPref("network.protocol-handler.app.mailto");
    } else {
      return "";
    }
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_logmail : ' + e);
  }
}
  
function set_pref_module(value) {
  try {
    prefs.setCharPref("opensi.serveur.module",value );
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_module : ' + e);
  }
}

function set_pref_ssl(value) {
  try {
    prefs.setBoolPref("opensi.serveur.ssl",value );
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_ssl : ' + e);
  }
}

function set_pref_ipserveur(value) {
  try {
    prefs.setCharPref("opensi.serveur.addresse",value );
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_ipserveur : ' + e);
  }
}

function set_pref_porttomcat(value) {
  try {
    prefs.setCharPref("opensi.serveur.port",value );
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_porttomcat : ' + e);
  }
}

function set_pref_servlet(value) {
  try {
    prefs.setCharPref("opensi.serveur.servlet",value );
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_servlet : ' + e);
  }
}

function set_pref_mailcomptable(value) {
  try {
    prefs.setCharPref("opensi.mailcomptable",value );
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_mailcomptable : ' + e);
  }
}

function set_pref_logmail(value) {
  try {
    prefs.setCharPref("network.protocol-handler.app.mailto",value );
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_logmail : ' + e);
  }
}

BASE_CALENDRIER = 2000 ;
MODULO = 2000 - BASE_CALENDRIER ;

function launchExternalMailer( res ){  
// res est une string transmise par l'element XUL d'origine de l'appel  
  try {
    if (res)  {    
      var url = "mailto:" + res;    
      var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);    
      var uri = ioService.newURI(url, null, null);
      var extProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);    
      extProtocolSvc.loadUrl(uri);  
    }
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#launchExternalMailer : ' + e);
  }
}

// =====================================================================
// =====================================================================
// =====================================================================

// ********************************************
// Rcupration de paramtre d'une requte HTTP
// ou rcupration des donnes d'un formulaire.
// Auteur : Oznog (www.trucsweb.com)
// ********************************************

// NE PAS MODIFIER CE CODE
var paramOk = true;

function FaitTableau(n) {
  // Cration d'un tableau (array)
  // aux dimensions du nombre de paramtres.

  try {
    
    this.length = n;
    for (var i = 0; i <= n; i++) {
      this[i] = 0
    }

    return this;
    
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#FaitTableau : ' + e);
  }
}


function ParamValeur(nValeur) {
  // Rcupration de la valeur d'une variable
  // Pour crer la variable en Javascript.
  
  try {

    if (paramOk) {
      var nTemp = "";
      for (var i=0;i<(param.length+1);i++) {
        if (param[i].substring(0,param[i].indexOf("=")) == nValeur)
          nTemp = param[i].substring(param[i].indexOf("=")+1,param[i].length)
      }
      return Decode(nTemp);
    } else {
      return '';
    }
    
  } catch (e) {
//    alert('erreur dans libs/util.js#ParamValeur : ' + e);
  }
}

// Decoder la requete HTTP
// manuellement pour le signe (+)
function Decode(tChaine) {  
  try {
  
    while (true) {
      var i = tChaine.indexOf('+');
      if (i < 0) break;
      tChaine = tChaine.substring(0,i) + '%20' + tChaine.substring(i + 1, tChaine.length);
    }
    return unescape(tChaine);
    
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#Decode : ' + e);
  }  
}


// =====================================================================
// =====================================================================
// =====================================================================


// ********************************************
// Recuperation du numero de session Expershop
// ********************************************
function cookie() {
	try {
		
  	return "S_="+ ParamValeur("S_") + nocache();
		
	} catch (e) {
    recup_erreur('erreur dans libs/util.js#cookie : ' + e);
  } 
}

function getDirServeur() {
  try {
 
    var url = get_pref_protocol() + "://";
    url += get_pref_ipserveur();
    url += ":" + get_pref_porttomcat();
    url += "/" + get_pref_servlet() + "/";
    return url;

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#getDirServeur : ' + e);
  }  
}

function url_openeas() {
  try {
    return getDirServeur() + "openeas";
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#url_openeas : ' + e);
  }  
}

function getUrlOpeneas(paramlist) {  
  try {
  
    var retour = url_openeas();
    if (paramlist != '') {
      retour += "?" + cookie() + paramlist;
    }
    return retour;

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#getUrlOpeneas : ' + e);
  }
}


function requeteHTTP(param,httpRequest,callbackFn,callbackParams) {

  try {
  
    if (httpRequest==undefined) {

      var p = new XMLHttpRequest();
      p.onload = null;
      p.open("POST",getUrlOpeneas(''), false);
      p.setRequestHeader("Content-type","application/x-www-form-urlencoded");
      p.send(param);
      return p;
      
    } else {

      httpRequest.onload = null;
  
      if (callbackFn==undefined) {
        httpRequest.open("POST",getUrlOpeneas(''), false);
      } else {
//        httpRequest.onreadystatechange = callbackFn;
//        httpRequest.onload = callbackFn;
        httpRequest.onload = function (aEvt) {
          callbackFn(httpRequest,callbackParams);
        };
        httpRequest.open("POST",getUrlOpeneas(''), true);
      }
      httpRequest.setRequestHeader("Content-type","application/x-www-form-urlencoded");
      httpRequest.send(param);

    }

  } catch (e) {
    alert("Le serveur est introuvable.\n Veuillez v\u00E9rifier son adresse et son port dans les param\u00E8tres avanc\u00E9s");
    alert(e);
    return p;
  }

}


// ************************************************
// Insertion d'un cookie dans la session Expershop
// ************************************************
function set_cookie(name,value) {
  try {
    var corps = cookie() + "&Page=SetCookie.tmpl" + "&Name=" + name + "&Value=" + value;
    requeteHTTP(corps);
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_cookie : ' + e);
  }
}

// ************************************************
// retourne le nombre d'exercices non cloturs
// ************************************************
function nb_exos_ouverts() {
  try {
  
    var corps = cookie() + "&Page=Compta/GetNonBloque.tmpl&ContentType=text";
	  var p = requeteHTTP(corps);
    if ( p.status != "200" ) {
   	 alert("Rception erreur " + p.status);
    } 
	  else return parseIntBis(p.responseText);

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#nb_exos_ouverts : ' + e);
  }
}

// ****************************************************************************
// retourne VRAI si l'exercice courant est le plus ancien exercice non clotur
// ****************************************************************************
function premier_exo_ouvert() {
  try {
  
    var corps = cookie() + "&Page=Compta/GetPremierOuvert.tmpl&ContentType=text";
	  var p = requeteHTTP(corps);
    if ( p.status != "200" ) {
   	 alert("Rception erreur " + p.status);
    } 
	  else {
      return ((get_cookie('Writeable') > '0') && (parseIntBis(p.responseText) == 0));
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#nb_exos_ouverts : ' + e);
  }
}


function format(valeur,decimal,separateur,nbch) {
// formate un chiffre avec 'decimal' chiffres aprs la virgule et un separateur

  try {

    var deci=Math.round( Math.pow(10,decimal)*(Math.abs(valeur)-Math.floor(Math.abs(valeur)))) ;
    var val=Math.floor(Math.abs(valeur));
    if (deci==Math.pow(10,decimal)) {
      val=Math.floor(Math.abs(valeur)) + 1;
      deci=0;
    }
    var val_format=val+"";
    var nb=val_format.length;
    for (var i=1;i<4;i++) {
      if (val>=Math.pow(10,(3*i))) {
        val_format=val_format.substring(0,nb-(3*i))+separateur+val_format.substring(nb-(3*i));
      }
    }
    if (decimal>0) {
      var decim="";
      for (var j=0;j<(decimal-deci.toString().length);j++) {decim+="0";}
      deci=decim+deci.toString();
      val_format=val_format+"."+deci;
    }
    switch (nbch) {
      case 1 :
        if (parseFloat(valeur)<10) {val_format="0"+val_format;}
        break;
      case 2 :
        if (parseFloat(valeur)<10) {val_format="0"+val_format;}
        break;
      case 3 :
        if (parseFloat(valeur)<10) {val_format="00"+val_format;}
        else if (parseFloat(valeur)<100) {val_format="0"+val_format;}
        break;
    }
    if (parseFloat(valeur)<0) {
      val_format="-"+val_format;
    }
    return val_format;

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#format : ' + e);
  }
}

/****************************************************
 *  @return le nombre de jours dans le mois correspondant  la saisie
 ****************************************************/
function nb_jours(mois,annee) {
  if (isNaN(annee)) {
    recup_erreur("erreur dans libs/util.js#nb_jours : mauvais format d'anne : " + annee );
    return false;
  }
  if (isNaN(mois)) {
    recup_erreur("erreur dans libs/util.js#nb_jours : mauvais format de mois : " + mois );
    return false;
  }
  switch (mois) {
    case 1:
    case 3:
    case 5:
    case 7:
    case 8:
    case 10:
    case 12:
      return 31;
      break;
    case 4:
    case 6:
    case 9:
    case 11:
      return 30;
      break;
    case 2:
      if ((annee != 0) && ((annee % 4) == 0)) {
        return 29;
      } else {
        return 28;
      }
      break;
    default:
      recup_erreur("erreur dans libs/util.js#nb_jours : mauvais format de mois : " + mois );
      return false;
      break;
  }
}

function get_mois(mois) {
  switch(mois) {
    case '01':
      return 'Janvier';
      break;
    case '02':
      return 'Fvrier';
      break;
    case '03':
      return 'Mars';
      break;
    case '04':
      return 'Avril';
      break;
    case '05':
      return 'Mai';
      break;
    case '06':
      return 'Juin';
      break;
    case '07':
      return 'Juillet';
      break;
    case '08':
      return 'Aout';
      break;
    case '09':
      return 'Septembre';
      break;
    case '10':
      return 'Octobre';
      break;
    case '11':
      return 'Novembre';
      break;
    case '12':
      return 'Dcembre';
      break;
    default:
      recup_erreur("erreur dans libs/util.js#get_mois : mauvais format de mois : " + mois );
      return false;
      break;
  }
}

// ************************************************
// Rcupration d'une date au format Expershop
// ************************************************
function get_date(day,month,year) {
  try {
  
    var corps = "&Page=GetDate.tmpl&ContentType=xml" + "&Day=" + day + "&Month=" + month + "&Year=" + year ;
    var p = requeteHTTP(corps);

    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
      return '';
    } else {
      var contenu=p.responseXML;
      var session = contenu.documentElement;
      return session.getAttribute('date');
    }  

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_date : ' + e);
  }
}

// ************************************************
// Rcupration d'un cookie de la session Expershop
// ************************************************
function get_cookie(name) {
  try {
  
    var corps = cookie() + "&Page=GetCookie.tmpl&ContentType=xml" + "&Name=" + name ;

    var p = requeteHTTP(corps);

    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
      return '';
    } else {
      var contenu=p.responseXML;
      var session = contenu.documentElement;
      return session.getAttribute('cookie');
    }  

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_cookie : ' + e);
  }
}


function reset_session(cookie) {
  try {
  
    var p = new XMLHttpRequest();
    p.onload = null;
  
    p.open("POST",getUrlOpeneas(''), false);
    p.setRequestHeader("Content-type","application/x-www-form-urlencoded");

    var corps = cookie + "&Page=SetCookie.tmpl&Reset=True";

    p.send(corps);
    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
    } 

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#reset_session : ' + e);
  }
}


function quit() {
	try {
  	reset_session(cookie());
  	var page = "chrome://opensi/content/login.xul";
  	window.open(page,'login','chrome');
  	window.parent.close();
		
	} catch (e) {
    recup_erreur('erreur dans libs/util.js#quit : ' + e);
  }
}


function retour_menu() {
  try {
    var page = "chrome://opensi/content/compta/user/menu.xul?" + cookie();
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#retour_menu : ' + e);
  }
}



// ****************************************************
// Chargement d'un arbre avec des donnes autognres
// ****************************************************
function loadTree(treeId, dsUrl) {

  try {

    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
    datasource = RDF.GetDataSource(dsUrl);
    var tree = document.getElementById(treeId);
    tree.database.AddDataSource(datasource);

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#loadTree : ' + e);
  }

}
	

function delete_tree() {
  try {
    var database = get_tree().database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
    get_tree().builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#delete_tree : ' + e);
  }
}

//****************************************************
// fonctions utiles
 
function rechecr(param) {
  try {
    var nom = "rech_ecr" ;
    var page = "chrome://opensi/content/compta/util/rechecriture.xul?" + cookie() ;
    if (param > 0) {
      page += "&global=true"
    }
    window.openDialog(page,nom,'chrome,modal');
/*
    delete_tree();
    get_tree().builder.rebuild();
    init();
*/
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#rechecr : ' + e);
  }
}

function parseNumEcriture(nom_ecriture){
  try {
    return 100 * parseInt(nom_ecriture.substring(0,1))
          + 10 * parseInt(nom_ecriture.substring(1,2))
          +      parseInt(nom_ecriture.substring(2,3));
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#parseNumEcriture : ' + e);
  }
}

function parseIntBis(nb) {
  try {

    switch (nb) {
      case '08':
      case '008':
        return 8;
        break;
      case '09':
      case '009':
        return 9;
        break;
      default:
        return parseInt(nb);
        break;
    }
    
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#parseIntBis : ' + e);
  }
}

function searchValue(a,s) {
  try {
    for (ii=0;ii<a.length;ii++) {
      if (a[ii] == s) return ii;
    }
    return -1;
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#searchValue : ' + e);
  }
}

// Message d'erreur
function recup_erreur(err) {
  try {
    var msg = urlEncode("Une erreur s'est produite. Merci de signaler ce bug \u00E0 l'\u00E9quipe d'OpenSI");
		showError(msg,urlEncode(err));
  } catch (e) {
    alert('erreur dans libs/util.js#recup_erreur : ' + e);
  }
}


function prepareDateJava(val) {
  try {
    return val.substring(6,10) + ':' + val.substring(3,5) + ':' + val.substring(0,2);
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#prepareDateJava : ' + e);
  }
}

function preparePeriodeJava(val) {
  try {
    return '20' + val.substring(2,4) + ':' + val.substring(0,2) + ':01';
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#preparePeriodeJava : ' + e);
  }
}

function urlEncode(strText) {
  try {

    return escape(strText);
    
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#urlEncode : ' + e);
  }
}

function rightCompleteString(str,c,n) {
  try {
  
    limite = n-str.length;
    for(i=0;i<limite;i++) {
      str += c;
    }
    return str;
    
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#rightCompleteString : ' + e);
  }
}

function formatNumber(number) {
	try {
		
		return number.toString().replace(/,/i,'.');//.replace(/ /gi,'');
		
	} catch (e) {
		recup_erreur('erreur dans libs/util.js#formatNumber : ' + e);
	}
}

function trim(str) {
  try {
	
	  var i = 0;
  	var lg = str.length;
	  var j = lg-1;

  	while (i<lg && ((str.charCodeAt(i)==9) || (str.charCodeAt(i)==10) || (str.charCodeAt(i)==13) || (str.charCodeAt(i)==32))) {
	  	i++;
	  }
		
  	while (j>i && ((str.charCodeAt(j)==9) || (str.charCodeAt(j)==10) || (str.charCodeAt(j)==13) || (str.charCodeAt(j)==32))) {
	  	j--;
	  }
		
	  return str.substring(i,j+1);

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#trim : ' + e);
  }
}

/* renvoie un parametre http fictif pour forcer le rechargement de la page a partir du serveur */
function nocache() {
	try {
		var nocache = new Date();
		return "&NoCache="+nocache.getMilliseconds();
	} catch (e) {
    recup_erreur('erreur dans libs/util.js#nocache : ' + e);
  }
}


function getFileName(path) {
	try {
		var lastslash = path.lastIndexOf('/');
		var lastantislash = path.lastIndexOf('\\');
		
		var lastsep = (lastslash>lastantislash)?lastslash:lastantislash;
		
		return path.substring(lastsep+1,path.length);
		
	} catch (e) {
    recup_erreur('erreur dans libs/util.js#getFileName : ' + e);
  }
}


function getFileExtension(file) {
	try {
	
		var lastPoint = file.lastIndexOf('.');
		
		if (lastPoint==-1 || lastPoint==file.length-1) {
			return "";
		}
		else {		
			return file.substring(lastPoint+1,file.length);
		}
	
	} catch (e) {
    recup_erreur('erreur dans libs/util.js#getFileExtension : ' + e);
  }
}


function existCompte(comptes,num_compte){
// vrifie si le compte numro <num_compte> existe
  try {
    for (i=0;i<comptes.length;i++) {
      if (String(num_compte) == String(comptes[i])) return true;
    }
    return false;
  } catch (e) {
    recup_erreur('erreur dans libs/util.js#existCompte : ' + e);
  }
}



/*** Message d'information ***/

function showMessage(msg) {
	try {
	
		var url = "chrome://opensi/content/popup/message.xul?"+ cookie() +"&Msg="+ urlEncode(msg);
		window.openDialog(url,'Information','chrome,modal');
		
	} catch (e) {
    recup_erreur('erreur dans libs/util.js#showMessage : ' + e);
  }	
}

/*** Message d'alerte ***/

function showWarning(msg) {
	try {
	
		var url = "chrome://opensi/content/popup/warning.xul?"+ cookie() +"&Msg="+ urlEncode(msg);
		window.openDialog(url,'Warning','chrome,modal');
		
	} catch (e) {
    recup_erreur('erreur dans libs/util.js#showWarning : ' + e);
  }	
}

/*** Message d'erreur ***/

function showError(msg,err) {
	try {

		var url = "chrome://opensi/content/popup/error.xul?"+ cookie();
    url += "&Msg="+ msg+ "&Err="+ err;
		window.openDialog(url,'Erreur','chrome,modal');
		
	} catch (e) {
    alert('erreur dans libs/util.js#showError : ' + e);
  }	
}



/* formattage des nombres selon un pattern */

// Original JavaScript code by Duncan Crombie: dcrombie@chirp.com.au
function formatNombre(number, format) {
	try {

		var separator = " ";  // use space as 000's separator
  	var decpoint = ".";  // use period as decimal point
  	var percent = "%";
  	var currency = "-";


  	if (number - 0 != number) return null;  // if number is NaN return null
  	var useSeparator = format.indexOf(separator) != -1;  // use separators in number
  	var usePercent = format.indexOf(percent) != -1;  // convert output to percentage
  	var useCurrency = format.indexOf(currency) != -1;  // use currency format
  	var isNegative = (number < 0);
  	number = Math.abs (number);
  	if (usePercent) number *= 100;
  	format = strip(format, separator + percent + currency);  // remove key characters
  	number = "" + number;  // convert number input to string

  	 // split input value into LHS and RHS using decpoint as divider
  	var dec = number.indexOf(decpoint) != -1;
  	var nleftEnd = (dec) ? number.substring(0, number.indexOf(".")) : number;
  	var nrightEnd = (dec) ? number.substring(number.indexOf(".") + 1) : "";

  	 // split format string into LHS and RHS using decpoint as divider
  	dec = format.indexOf(decpoint) != -1;
  	var sleftEnd = (dec) ? format.substring(0, format.indexOf(".")) : format;
  	var srightEnd = (dec) ? format.substring(format.indexOf(".") + 1) : "";

  	 // adjust decimal places by cropping or adding zeros to LHS of number
  	if (srightEnd.length < nrightEnd.length) {
    	var nextChar = nrightEnd.charAt(srightEnd.length) - 0;
    	nrightEnd = nrightEnd.substring(0, srightEnd.length);
    	if (nextChar >= 5) nrightEnd = "" + ((nrightEnd - 0) + 1);  // round up

	// patch provided by Patti Marcoux 1999/08/06
    	while (srightEnd.length > nrightEnd.length) {
      	nrightEnd = "0" + nrightEnd;
    	}

    	if (srightEnd.length < nrightEnd.length) {
      	nrightEnd = nrightEnd.substring(1);
      	nleftEnd = (nleftEnd - 0) + 1;
    	}
  	} else {
    	for (var i=nrightEnd.length; srightEnd.length > nrightEnd.length; i++) {
      	if (srightEnd.charAt(i) == "0") nrightEnd += "0";  // append zero to RHS of number
      	else break;
    	}
  	}

  	 // adjust leading zeros
  	sleftEnd = strip(sleftEnd, "#");  // remove hashes from LHS of format
  	while (sleftEnd.length > nleftEnd.length) {
    	nleftEnd = "0" + nleftEnd;  // prepend zero to LHS of number
  	}

  	if (useSeparator) nleftEnd = separate(nleftEnd, separator);  // add separator
  	var output = nleftEnd + ((nrightEnd != "") ? "." + nrightEnd : "");  // combine parts
  	output = ((useCurrency) ? currency : "") + output + ((usePercent) ? percent : "");
  	if (isNegative) {
    	// patch suggested by Tom Denn 25/4/2001
    	output = (useCurrency) ? "(" + output + ")" : "-" + output;
  	}
  	return output;
	
	} catch (e) {
    alert('erreur dans libs/util.js#formatNumber : ' + e);
  }
}

// utilise par formatNombre
function strip(input, chars) {  // strip all characters in 'chars' from input
  var output = "";  // initialise output string
  for (var i=0; i < input.length; i++)
    if (chars.indexOf(input.charAt(i)) == -1)
      output += input.charAt(i);
  return output;
}

// utilise par formatNombre
function separate(input, separator) {  // format input using 'separator' to mark 000's
  input = "" + input;
  var output = "";  // initialise output string
  for (var i=0; i < input.length; i++) {
    if (i != 0 && (input.length - i) % 3 == 0) output += separator;
    output += input.charAt(i);
  }
  return output;
}

function loadHtml(tmpl) {
		window.location = getUrlOpeneas('&Page=Manager/' + tmpl);
}

function nope(x){
}