/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {
		
		init_tree();
  
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/reglement.js#init : ' + e);
  }
}

function disableSup(b) {
	try {
		
		var tree = document.getElementById('liste_modes');
		
		if (tree.contentView!=null && tree.currentIndex!=-1) {
			document.getElementById('bSupprimer').disabled = b;
		}
		
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/reglement.js#enableSup : ' + e);
  }
}


function supprimerMode() {
	try {
	
		var tree = document.getElementById('liste_modes');
		
		if (tree.contentView!=null && tree.currentIndex!=-1) {
		
			var selection = tree.contentView.getItemAtIndex(tree.currentIndex);
			var mode_r = selection.firstChild.firstChild.getAttribute('label');

			if (window.confirm("Confirmez-vous la suppression du mode de rglement '"+ mode_r +"' ?")) {		
				var corps = cookie() + "&Page=Manager/Parametrage/supprimerReglement.tmpl&ContentType=text&Mode_R="+ urlEncode(mode_r);

				var p = requeteHTTP(corps);

  			if (p.status != "200") {
      		alert("Rception erreur " + p.status);
  			} 
				else {
					delete_tree();
					init_tree();
					document.getElementById('bSupprimer').disabled = true;
  			}
			}
		}
		
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/reglement.js#supprimerMode : ' + e);
  }
}


function enregistrerMode(mode) {
	try {
		
		var mode_r = document.getElementById('Mode_R').value;

		if (isEmpty(mode_r)) {
			alert("Veuillez remplir le champ 'Mode de rglement' !");
		}
		else {
			var corps = cookie() + "&Page=Manager/Parametrage/creerReglement.tmpl&ContentType=text&Mode_R="+ urlEncode(mode_r);

			var p = requeteHTTP(corps);           

  		if (p.status != "200") {
      	alert("Rception erreur " + p.status);
  		} 
			else {
				delete_tree();
				init_tree();
				document.getElementById('Mode_R').value = '';
  		}
		}
		
	} catch (e) {
    recup_erreur('erreur dans manager/parametrage/reglement.js#enregistrerMode : ' + e);
  }
}


function init_tree() {
  try {		
    var paramlist = "&Page=Manager/GetRDF/modes_reglement.tmpl&ContentType=xml";    
    load_rdf('liste_modes', getUrlOpeneas(paramlist));
    document.getElementById('liste_modes').builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans manager/parametrage/reglement.js#init_tree : ' + e);
  }
}

function delete_tree() {
  try {
    var database = document.getElementById("liste_modes").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans manager/parametrage/reglement.js#delete_tree : ' + e);
  }
}
