/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/manager/choix_dossier_plan.xul>
 * @include chrome://opensi/content/util.js
 *
 */

function init() {
	try {
		var paramlist = "&Page=Compta/GetRDF/RechercheDossier.tmpl&ContentType=xml";
  	load_rdf('liste_dossiers', getUrlOpeneas(paramlist));
  	document.getElementById('Dossier_Id').focus();
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/choix_dossier_plan.js#init : ' + e);
  }
}

function ouvrirPlan() {
	try {
		var dossier = document.getElementById("Dossier_Id").value; 
		document.getElementById("Dossier_Id").value = '';

		if (isEmpty(dossier))
			alert('Veuillez spcifier un nom de dossier !');
		else if (!isCleAlpha(dossier)) {
			alert('Nom de dossier incorrect !');
		}
		else if (!existeDossier(dossier)) {
			alert('Dossier inexistant !');
		}
		else {
			var page = "chrome://opensi/content/manager/plan_comptable/gestion_plan.xul?" + cookie() +"&Dossier_Id="+ dossier;
  		window.location = page;
		}
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/choix_dossier_plan.js#ouvrirPlan : ' + e);
  }
}

function keypress(e) {  
  try {  
    switch (e.keyCode) {
      case 13: ouvrirPlan(); break;
    }
  } catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/choix_dossier_plan.js#keypress : ' + e);
  }
}

function existeDossier(dossier) {
	try {
  	var v = document.getElementById('liste_dossiers').view;
		var existe = false;
		var i = 0;

  	while (i<v.rowCount && !existe) {
    	existe = dossier.toUpperCase() == v.getCellText(i,'dossier_id').toUpperCase();
			i++;
  	}
  	return existe;
	} catch (e) {
    recup_erreur('erreur dans manager/journaux/choix_dossier_journaux.js#existeDossier : ' + e);
  }
}

function reporter(tree) {
	try {
  	var selection = tree.contentView.getItemAtIndex(tree.currentIndex);
  	var text = selection.firstChild.firstChild.getAttribute("label");
  	document.getElementById("Dossier_Id").value = text;
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/choix_dossier_plan.js#reporter : ' + e);
  }
}


function retour_menuManager() {
	try {
  	var page = "chrome://opensi/content/manager/menu_manager.xul?" + cookie() ;
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/choix_dossier_plan.js#retour_menuManager : ' + e);
  }
}
