/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/manager/choix_dossier_plan.xul>
 * @include chrome://opensi/content/util.js
 *
 */

var dossier;
var base;

function init() {
	try {
		dossier = ParamValeur("Dossier_Id");
		document.getElementById("titre").value = 'PLAN COMPTABLE DU DOSSIER "' + dossier + '"';
		document.getElementById("Numero_Compte").focus();
		
		document.getElementById("Lettrage").selectedItem = document.getElementById("Lettrage_Non");
		document.getElementById("Cumul_Journal").selectedItem = document.getElementById("Cumul_Non");
		document.getElementById("Centraliser").selectedItem = document.getElementById("Centraliser_Non");
		document.getElementById("Detail_Cloture").selectedItem = document.getElementById("Detail_Non");
		
		paramlist = "&Page=Compta/GetRDF/tva_manager.tmpl&ContentType=xml";
  	load_rdf_async('Taux_Tva', getUrlOpeneas(paramlist), initTva);

		var corps = cookie() + "&Page=Manager/GetBase.tmpl&ContentType=xml&Dossier_Id="+ dossier;		
    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,init2);
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#init : ' + e);
  }
}

function init2(httpRequest) {
	try {

  	if (httpRequest.status != "200") {
    	alert("Rception erreur " + httpRequest.status);
  	} 
		else {
    	var contenu = httpRequest.responseXML;
			base = contenu.documentElement.getAttribute('nom');

			var paramlist = "&Page=Compta/GetRDF/liste_comptes_manager.tmpl&ContentType=xml&Base="+ base +"&Compte_Gen=F";
  		load_rdf('fournisseurs', getUrlOpeneas(paramlist));

			paramlist = "&Page=Compta/GetRDF/liste_comptes_manager.tmpl&ContentType=xml&Base="+ base +"&Compte_Gen=C";
  		load_rdf('clients', getUrlOpeneas(paramlist));

			loadLike("10");loadLike("11");loadLike("12");loadLike("13");loadLike("14");loadLike("15");loadLike("16");loadLike("17");loadLike("18");
			loadLike("20");loadLike("21");loadLike("22");loadLike("23");loadLike("25");loadLike("26");loadLike("27");loadLike("28");loadLike("29");
			loadLike("31");loadLike("32");loadLike("33");loadLike("34");loadLike("35");loadLike("36");loadLike("37");loadLike("38");loadLike("39");
			loadLike("40");loadLike("41");loadLike("42");loadLike("43");loadLike("44");loadLike("45");loadLike("46");loadLike("47");loadLike("48");loadLike("49");
			loadLike("50");loadLike("51");loadLike("53");loadLike("54");loadLike("58");loadLike("59");
			loadLike("60");loadLike("61");loadLike("62");loadLike("63");loadLike("64");loadLike("65");loadLike("66");loadLike("67");loadLike("68");loadLike("69");
			loadLike("70");loadLike("71");loadLike("72");loadLike("73");loadLike("74");loadLike("75");loadLike("76");loadLike("77");loadLike("78");loadLike("79");
		}
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#init : ' + e);
  }
}

function initTva() {
	try {
		document.getElementById('Taux_Tva').selectedIndex = 0;
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#initTva : ' + e);
  }
}

function loadLike(like) {
	try {
		var paramlist = "&Page=Compta/GetRDF/liste_comptes_manager.tmpl&ContentType=xml&Base="+ base +"&Like="+ like;
  	load_rdf("R"+like, getUrlOpeneas(paramlist));
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#loadLike : ' + e);
  }
}

function modifierCompte() {

	try {

		var numero_compte = document.getElementById('Numero_Compte').value;		
		var libelle = document.getElementById('Libelle').value;
		var compte_gen;
		var taux_tva;
		
		if (numero_compte.substring(0,1)=='0') {
			compte_gen = document.getElementById('Compte_Gen').value;
		} else {
			compte_gen = 'G';
		}
		
		if (numero_compte.substring(0,1)=='1' || numero_compte.substring(0,1)=='3') {
			taux_tva = 1;
		} else {
			taux_tva = document.getElementById('Taux_Tva').value;
		}
		
		var lettrage = document.getElementById('Lettrage').value;		
		var centraliser = document.getElementById('Centraliser').value;
		var cumul_journal = document.getElementById('Cumul_Journal').value;
		var detail_cloture = document.getElementById('Detail_Cloture').value;
		
		if (isEmpty(libelle)) {
			alert('Le champ "Libelle" est obligatoire !');
		} else if (window.confirm('Confirmez-vous la modification du compte "'+ numero_compte +'" ?')) {		
			var corps = cookie() + "&Page=Manager/ModifierCompte.tmpl&ContentType=text&Dossier_Id="+ dossier;
			corps += "&Numero_Compte="+ numero_compte +"&Libelle="+ libelle +"&Compte_Gen="+ compte_gen +"&Taux_Tva="+ taux_tva;
			corps += "&Lettrage="+ lettrage +"&Centraliser="+ centraliser +"&Cumul_Journal="+ cumul_journal +"&Detail_Cloture="+ detail_cloture;
      var httpRequest = new XMLHttpRequest();
      requeteHTTP(corps,httpRequest,modifierCompte2,numero_compte);
		}
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#modifierCompte : ' + e);
  }
}

function modifierCompte2(httpRequest,numero_compte) {
  try {
  	if ( httpRequest.status != "200" ) {
    	alert("Rception erreur " + httpRequest.status);
  	} else {
      alert(trim(httpRequest.responseText));
    }
    if (numero_compte.substring(0,1)=='0') {
      reinit_tree("fournisseurs");
      reinit_tree("clients");
    } else {
      reinit_tree(numero_compte.substring(0,2));
    }
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#modifierCompte2 : ' + e);
  }    
}

function nouveauCompte() {
	try {
		document.getElementById('clc').collapsed = false;
		document.getElementById('msn').collapsed = true;
		document.getElementById('Numero_Compte').disabled = false;
		document.getElementById('Numero_Compte').value = '';
		document.getElementById('Libelle').value = '';
		document.getElementById("Lettrage").selectedItem = document.getElementById("Lettrage_Non");
		document.getElementById("Cumul_Journal").selectedItem = document.getElementById("Cumul_Non");
		document.getElementById("Centraliser").selectedItem = document.getElementById("Centraliser_Non");
		document.getElementById("Detail_Cloture").selectedItem = document.getElementById("Detail_Non");
		document.getElementById('boxCompte_Gen').collapsed = true;
		document.getElementById('libCompte_Gen').collapsed = true;
		document.getElementById('boxTaux_Tva').collapsed = false;
		document.getElementById('libTaux_Tva').collapsed = false;
		document.getElementById('Taux_Tva').selectedIndex = 0;
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#nouveauCompte : ' + e);
  }
}

function leaveNumero_Compte() {
	try {
		var numero_compte = document.getElementById('Numero_Compte').value;
		
		if (numero_compte.substring(0,1)=='0') {
			document.getElementById('boxCompte_Gen').collapsed = false;
			document.getElementById('libCompte_Gen').collapsed = false;
		}
		else {
			document.getElementById('boxCompte_Gen').collapsed = true;
			document.getElementById('libCompte_Gen').collapsed = true;
		}
		
		if (numero_compte.substring(0,1)=='1' || numero_compte.substring(0,1)=='3') {
			document.getElementById('boxTaux_Tva').collapsed = true;
			document.getElementById('libTaux_Tva').collapsed = true;
		}
		else {
			document.getElementById('boxTaux_Tva').collapsed = false;
			document.getElementById('libTaux_Tva').collapsed = false;
		}
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#leaveNumero_Compte : ' + e);
  }
}

function supprimerCompte() {
	try {
		var numero_compte = document.getElementById('Numero_Compte').value;
		if (numero_compte=='40100000' || numero_compte=='41100000' || numero_compte=='12000000' || numero_compte=='47210100') {
			alert("Le compte '"+ numero_compte +"' ne peut pas tre supprim !");
		} else {
			if (window.confirm('Confirmez-vous la suppression du compte "'+ numero_compte +'" ?')) {			
				var corps = cookie() + "&Page=Manager/SupprimerCompte.tmpl&ContentType=text";
        corps += "&Dossier_Id="+ dossier +"&Numero_Compte="+ numero_compte;
        var httpRequest = new XMLHttpRequest();
        requeteHTTP(corps,httpRequest,supprimerCompte2,numero_compte);
			}
		}
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#supprimerCompte : ' + e);
  }
}

function supprimerCompte2(httpRequest,numero_compte) {
  try {
    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + httpRequest.status);
    } else {
      alert(trim(httpRequest.responseText));
    }
    nouveauCompte();
    if (numero_compte.substring(0,1)=='0') {
      reinit_tree("fournisseurs");
      reinit_tree("clients");
    } else {
      reinit_tree(numero_compte.substring(0,2));
    }
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#supprimerCompte2 : ' + e);
  }    
}

function creerCompte() {
	try {
		var numero_compte = document.getElementById('Numero_Compte').value;		
		var libelle = document.getElementById('Libelle').value;		
		var compte_gen;
		var taux_tva;
		
		if (numero_compte.substring(0,1)=='0') {
			compte_gen = document.getElementById('Compte_Gen').value;
		}
		else {
			compte_gen = 'G';
		}
		
		if (numero_compte.substring(0,1)=='1' || numero_compte.substring(0,1)=='3') {
			taux_tva = 1;
		}
		else {
			taux_tva = document.getElementById('Taux_Tva').value;
		}
		
		var lettrage = document.getElementById('Lettrage').value;		
		var centraliser = document.getElementById('Centraliser').value;
		var cumul_journal = document.getElementById('Cumul_Journal').value;
		var detail_cloture = document.getElementById('Detail_Cloture').value;
	
		if (isEmpty(numero_compte) || isEmpty(libelle)) {
			alert('Les champs "Numero de compte" et "Libelle" sont obligatoires !');
		}	else if (!isCompteCorrect(numero_compte)) {
			alert('Numero de compte incorrect !');
		} else if (window.confirm('Confirmez-vous la cration du compte "'+ numero_compte +'" ?')) {
			var corps = cookie() + "&Page=Manager/CreerCompte.tmpl&ContentType=text&Dossier_Id="+ dossier;
			corps += "&Numero_Compte="+ numero_compte +"&Libelle="+ libelle +"&Compte_Gen="+ compte_gen +"&Taux_Tva="+ taux_tva;
			corps += "&Lettrage="+ lettrage +"&Centraliser="+ centraliser +"&Cumul_Journal="+ cumul_journal +"&Detail_Cloture="+ detail_cloture;
      var httpRequest = new XMLHttpRequest();
      var httpParams = new Array(numero_compte,compte_gen);
      requeteHTTP(corps,httpRequest,creerCompte2,httpParams);
		}
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#creerCompte : ' + e);
  }
}

function creerCompte2(httpRequest,httpParams) {
  try {
    var numero_compte = httpParams[0];
    var compte_gen = httpParams[1];
    if ( httpRequest.status != "200" ) {
      alert("Rception erreur " + httpRequest.status);
    } else {
		  alert(trim(httpRequest.responseText));
		}
		document.getElementById('clc').collapsed = true;
		document.getElementById('msn').collapsed = false;
		document.getElementById('Numero_Compte').disabled = true;
		if (compte_gen=='F') {
		  reinit_tree("fournisseurs");
		} else if (compte_gen=='C') {
		  reinit_tree("clients");
		} else {
			reinit_tree(numero_compte.substring(0,2));
		}
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#creerCompte2 : ' + e);
  }
}


function ouvrirCompte() {
	try {		
		var tree = document.getElementById('plan_comptable');
		if (tree.currentIndex!=-1) {
			var selection = tree.contentView.getItemAtIndex(tree.currentIndex);		
  		var numero_compte = selection.firstChild.firstChild.getAttribute("value");		
  		if (numero_compte!='') {		
				document.getElementById('clc').collapsed = true;
				document.getElementById('msn').collapsed = false;
				document.getElementById('Numero_Compte').disabled = true;
				var corps = "Page=Manager/ChampsCompte.tmpl&ContentType=xml&Base="+ base +"&Numero_Compte="+ numero_compte;		
        var httpRequest = new XMLHttpRequest();
        requeteHTTP(corps,httpRequest,ouvrirCompte2,numero_compte);
			}
		}
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#ouvrirCompte : ' + e);
  }
}

function ouvrirCompte2(httpRequest,numero_compte) {

	try {		

    if (httpRequest.status != "200") {
      alert("Rception erreur " + p.status);
    } else {

      var contenu = httpRequest.responseXML;
      compte = contenu.documentElement;

			document.getElementById('Numero_Compte').value = compte.getAttribute('numero_compte');
			document.getElementById('Libelle').value = compte.getAttribute('libelle');

			if (numero_compte.substring(0,1)=='0') {
				document.getElementById('boxCompte_Gen').collapsed = false;
				document.getElementById('libCompte_Gen').collapsed = false;
				document.getElementById('Compte_Gen').value = compte.getAttribute('compte_gen');
			} else {
				document.getElementById('boxCompte_Gen').collapsed = true;
				document.getElementById('libCompte_Gen').collapsed = true;
			}

			if (numero_compte.substring(0,1)=='1' || numero_compte.substring(0,1)=='3') {
				document.getElementById('boxTaux_Tva').collapsed = true;
				document.getElementById('libTaux_Tva').collapsed = true;
			}	else {					
				document.getElementById('boxTaux_Tva').collapsed = false;
				document.getElementById('libTaux_Tva').collapsed = false;
				document.getElementById('Taux_Tva').value = compte.getAttribute('taux_tva');
			}

			document.getElementById('Lettrage').value = compte.getAttribute('lettrage');
			document.getElementById('Centraliser').value = compte.getAttribute('centraliser');
			document.getElementById('Cumul_Journal').value = compte.getAttribute('cumul_journal');
			document.getElementById('Detail_Cloture').value = compte.getAttribute('detail_cloture');

			if (document.getElementById("Lettrage").value == "y") {
			  document.getElementById("Lettrage").selectedItem = document.getElementById("Lettrage_Oui");
			}	else {
				document.getElementById("Lettrage").selectedItem = document.getElementById("Lettrage_Non");
			}

			if (document.getElementById("Centraliser").value == "y") {
				document.getElementById("Centraliser").selectedItem = document.getElementById("Centraliser_Oui");
			}	else {
				document.getElementById("Centraliser").selectedItem = document.getElementById("Centraliser_Non");
			}

			if (document.getElementById("Cumul_Journal").value == "y") {
				document.getElementById("Cumul_Journal").selectedItem = document.getElementById("Cumul_Oui");
			}	else {
				document.getElementById("Cumul_Journal").selectedItem = document.getElementById("Cumul_Non");
			}

			if (document.getElementById("Detail_Cloture").value == "y") {
				document.getElementById("Detail_Cloture").selectedItem = document.getElementById("Detail_Oui");
			}	else {
			  document.getElementById("Detail_Cloture").selectedItem = document.getElementById("Detail_Non");
			}

		}

	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#ouvrirCompte : ' + e);
  }

}

function reinit_tree(like) {
	try {
		delete_tree(like);
		init_tree(like);
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#reinit_tree : ' + e);
  }
}

function init_tree(like) {
  try {
		var paramlist;
	
		if (like=="fournisseurs") {
			paramlist = "&Page=Compta/GetRDF/liste_comptes_manager.tmpl&ContentType=xml&Base="+ base +"&Compte_Gen=F";
  		load_rdf('fournisseurs', getUrlOpeneas(paramlist));
			document.getElementById("fournisseurs").builder.rebuild();
		}
		else if (like=="clients") {
			paramlist = "&Page=Compta/GetRDF/liste_comptes_manager.tmpl&ContentType=xml&Base="+ base +"&Compte_Gen=C";
  		load_rdf('clients', getUrlOpeneas(paramlist));
			document.getElementById("clients").builder.rebuild();
		}
		else {
			loadLike(like);
			document.getElementById("R"+like).builder.rebuild();
		}    
  } catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#init_tree : ' + e);
  }
}

function delete_tree(like) {
  try {
		var database;
		
		if (like=="fournisseurs") {
			database = document.getElementById("fournisseurs").database;
		}
		else if (like=="clients") {
			database = document.getElementById("clients").database;
		}
		else {
			database = document.getElementById("R"+like).database;
		}	
    
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#delete_tree : ' + e);
  }
}

function keypress(e) {
	try {
		switch (e.keyCode) {
      case 13: ouvrirCompte(); break;
    }
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#keypress : ' + e);
  }
}

function retour_menuManager() {
	try {
  	var page = "chrome://opensi/content/manager/menu_manager.xul?" + cookie() ;
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans manager/plan_comptable/gestion_plan.js#retour_menuManager : ' + e);
  }
}